unit FreqUnit;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils, constgts,
  graphe, gtsmain, gtsutil, gtsdef, FloatEdit, ComCtrls;

type
  TFrequenceDlg = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    ActiveBtn: TBitBtn;
    DesactiveBtn: TBitBtn;
    MiniEdit: TFloatEdit;
    MaxiEdit: TFloatEdit;
    LogCB: TCheckBox;
    procedure ActiveBtnClick(Sender: TObject);
    procedure DesactiveBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure MaxiEditChange(Sender: TObject);
    procedure MiniEditChange(Sender: TObject);
  private
  public
  end;

var
  FrequenceDlg: TFrequenceDlg;

implementation

{$R *.DFM}

procedure TFrequenceDlg.ActiveBtnClick(Sender: TObject);
begin with frequence do begin
    active := true;
    mini :=  miniEdit.value;
    maxi :=  maxiEdit.value;
    frequence.AxeLog := LogCB.checked;
end end;

procedure TFrequenceDlg.DesactiveBtnClick(Sender: TObject);
begin
    frequence.active := false
end;

procedure TFrequenceDlg.FormActivate(Sender: TObject);
begin with frequence do begin
       MiniEdit.value := Mini;
       MiniEdit.maxValue := Maxi/10;
       MaxiEdit.value := Maxi;
       MaxiEdit.minValue := Mini*10;
       LogCB.checked := AxeLog;
end end;

procedure TFrequenceDlg.MaxiEditChange(Sender: TObject);
begin
       MiniEdit.maxValue := MaxiEdit.value/10
end;

procedure TFrequenceDlg.MiniEditChange(Sender: TObject);
begin
       MaxiEdit.minValue := MiniEdit.value*10
end;

end.
