unit GTSCFG;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils,
  gtsUtil, gtsDef, graphe, gtsmain, maths,
  listecap, etalon, constgts, ImgList, ComCtrls, aidekey;

type
  TOrphyGtsDlg = class(TForm)
    OKBtn: TBitBtn;
    GrandeurGB: TGroupBox;
    EditNom: TEdit;
    EditUnite: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    Bevel1: TBevel;
    EntreeCB: TComboBox;
    CapteursBtn: TBitBtn;
    DesactiveBtn: TBitBtn;
    Timer: TTimer;
    EtalonnageGB: TGroupBox;
    EtalonneInterBtn: TBitBtn;
    HelpBtn: TBitBtn;
    ImagePoint: TImageList;
    EditSignif: TEdit;
    Label3: TLabel;
    AffichageGB: TGroupBox;
    EditValeur: TEdit;
    Label6: TLabel;
    BevelZero: TBevel;
    Label0V: TLabel;
    val0Edit: TEdit;
    PenteEdit: TEdit;
    PenteLabel: TLabel;
    AvecPotarLabel: TLabel;
    CouleurCombo: TColorBox;
    LabelAide: TLabel;
    EtalonCB: TCheckBox;
    Gain6CB: TCheckBox;
    ModuleRaccordLabel: TLabel;
    AideLabel: TLabel;
    PointCombo: TComboBoxEx;
    MasseRG: TRadioGroup;
    Gauge1: TProgressBar;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure DesactiveBtnClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure EditNomChange(Sender: TObject);
    procedure CapteursBtnClick(Sender: TObject);
    procedure EtalonneInterBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure ManuelGridClick(Sender: TObject);
    procedure EditNomKeyPress(Sender: TObject; var Key: Char);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure EntreeCBChange(Sender: TObject);
    procedure EtalonRGClick(Sender: TObject);
    procedure val0EditExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure val0EditKeyPress(Sender: TObject; var Key: Char);
    procedure NonLineaireCBClick(Sender: TObject);
    procedure MasseFlottanteCBClick(Sender: TObject);
    procedure Gain6CBClick(Sender: TObject);
  private
    oldNum : byte;
    oldActive : boolean;
    voieVolt,voieCapteur : Tvoie;
    function CalculEtalonManuel : boolean;
    procedure SetEtalonnage;
    procedure SetMasse;
  public
    voieCourante : Tvoie;
    modif : boolean;
  end;

var
  OrphyGtsDlg: TOrphyGtsDlg;

implementation

{$R *.DFM}

procedure TOrphyGtsDlg.FormActivate(Sender: TObject);
begin
    with voieCourante do begin
          EditNom.text := Nom;
          EditUnite.text := NomUnite;
          EditSignif.text := Signif;
          LabelAide.caption := Aide;
          EntreeCB.ItemIndex := numOrphy;
          oldNum := numOrphy;
          oldActive := active;
          EtalonCB.checked := avecCapteur;
          CouleurCombo.selected := couleur;
          PointCombo.itemIndex := ord(motif);
          val0Edit.text := FormatGts(offset);
          penteEdit.text := FormatGts(unVolt);
          gain6CB.Checked := gain6; 
          penteLabel.caption := deltaMaj+nom+'/'+DeltaMaj+'V ('+
              nomUnite+'/V)';
          if avecCapteur
             then begin
                  voieCapteur.mini := mini;
                  voieCapteur.maxi := maxi;
                  voieCapteur.nomUnite := nomUnite;
                  voieCapteur.signif := signif;
                  voieCapteur.aide := aide;
             end
             else begin
                  voieVolt.mini := mini;
                  voieVolt.maxi := maxi;
                  voieVolt.signif := signif;
             end;
          moduleRaccordLabel.Visible := (numOrphy<4);
          gain6CB.Visible := (numOrphy<4);          
    end;
    MasseRG.itemIndex := ord(masseFlottante);
    SetEtalonnage;
    setMasse;
    Timer.enabled := true;
    modif := false;
end;

procedure TOrphyGtsDlg.SetEtalonnage;
var oldCapteur : boolean;
begin
     EtalonnageGB.visible := EtalonCB.checked;
     if EtalonnageGB.visible
        then height := 470
        else height := 470-EtalonnageGB.height;
with voieCourante do begin
     oldCapteur := avecCapteur;
     avecCapteur := EtalonCB.checked;
     if oldCapteur<>avecCapteur then
        if avecCapteur
           then begin
              voieVolt.mini := mini;
              voieVolt.maxi := maxi;
              voieVolt.signif := EditSignif.text;
              EditUnite.text := voieCapteur.nomUnite;
              EditSignif.text := voieCapteur.signif;
              CalculEtalonManuel;
           end
           else begin
              voieCapteur.mini := mini;
              voieCapteur.maxi := maxi;
              voieCapteur.nomUnite := EditUnite.text;
              voieCapteur.signif := EditSignif.text;
              EditUnite.text := 'V';
              EditSignif.text := voieVolt.signif;
           end;
     AvecPotarLabel.visible := avecPotar and avecCapteur;
     AideLabel.caption := aide;
end end;

procedure TOrphyGtsDlg.OKBtnClick(Sender: TObject);
begin
     timer.enabled := false;
     modif := modif or not oldActive;
     with voieCourante do begin
          AvecCapteur := EtalonCB.checked;
          Nom := EditNom.text;
          if avecCapteur
             then NomUnite := EditUnite.text
             else NomUnite := 'V';
          numOrphy := EntreeCB.ItemIndex;
          Signif := EditSignif.text;
          active := true;
          couleur := CouleurCombo.selected;
          motif := Tmotif(PointCombo.itemIndex);
          setMinMax;
     end;
end;

procedure TOrphyGtsDlg.DesactiveBtnClick(Sender: TObject);
begin
      modif := modif or oldActive;
      voieCourante.active := false;
end;

procedure TOrphyGtsDlg.FormDeactivate(Sender: TObject);
begin
    timer.enabled := false
end;

procedure TOrphyGtsDlg.TimerTimer(Sender: TObject);
var valeur : integer;
begin
     try
     valeur := GtsMainForm.getByte(64+voieCourante.numOrphy);
     Gauge1.position := valeur;
     with voieCourante do
         EditValeur.text := formatGTS(valeurReal(valeur));
     except
         Gauge1.position := 0
     end;
end;

procedure TOrphyGtsDlg.EditNomChange(Sender: TObject);
begin
     penteLabel.caption := deltaMaj+EditNom.text+'/'+DeltaMaj+'V ('+
        EditUnite.text+'/V)';
     AffichageGB.caption := trAffichage+EditUnite.text+')';
end;

function TOrphyGtsDlg.CalculEtalonManuel : boolean;
begin with voieCourante do begin
      try
          Offset := GetFloat(val0Edit.text);
          UnVolt := GetFloat(penteEdit.text);
          result := true;
      except
          afficheErreur(erNombre);
          result := false;
      end;
end end;

procedure TOrphyGtsDlg.CapteursBtnClick(Sender: TObject);
begin
     timer.enabled := false;
     ListeCapteursDlg.voieCourante := voieCourante;
     if ListeCapteursDlg.showModal=mrOK then begin
        FormActivate(nil);
        modif := true;
     end;
     timer.enabled := true;
end;

procedure TOrphyGtsDlg.EtalonneInterBtnClick(Sender: TObject);
begin with voieCourante do begin
     timer.enabled := false;
     Nom := EditNom.text;
     NomUnite := EditUnite.text;
     EtalonneInterDlg := TEtalonneInterDlg.create(self);
     EtalonneInterDlg.voieCourante := voieCourante;
     if EtalonneInterDlg.showModal=mrOK then begin
         val0Edit.text := FormatGts(offset);
         penteEdit.text := FormatGts(UnVolt);
         etalonCB.checked := true;
         setEtalonnage;
     end;
     modif := true;
     timer.enabled := true;
     EtalonneInterDlg.free;
end end;

procedure TOrphyGtsDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     timer.enabled := false
end;

procedure TOrphyGtsDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_Voies)
end;

procedure TOrphyGtsDlg.ManuelGridClick(Sender: TObject);
begin
     Modif := true
end;

procedure TOrphyGtsDlg.EditNomKeyPress(Sender: TObject; var Key: Char);
begin
     if not charinset(key,(majuscule+minuscule+grecque+toucheEdition+chiffre)) then key := #0
end;

procedure TOrphyGtsDlg.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
     if EtalonCB.checked and
        not CalculEtalonManuel then begin
          afficheErreur(erEtalon);
          canClose := false;
          timer.enabled := true;
     end;
end;

procedure TOrphyGtsDlg.EntreeCBChange(Sender: TObject);
begin
     voieCourante.numOrphy := EntreeCB.ItemIndex;
     moduleRaccordLabel.Visible := (VoieCourante.numOrphy<4);
end;

procedure TOrphyGtsDlg.EtalonRGClick(Sender: TObject);
begin
     modif := true;
     setEtalonnage;
end;

procedure TOrphyGtsDlg.val0EditExit(Sender: TObject);
begin
     CalculEtalonManuel;
     FormActivate(sender);
end;

procedure TOrphyGtsDlg.FormCreate(Sender: TObject);
begin
     voieVolt := Tvoie.create(1);
     voieCapteur := Tvoie.create(1);
end;

procedure TOrphyGtsDlg.val0EditKeyPress(Sender: TObject; var Key: Char);
begin
     VerifKeyGetFloat(key);
     if key=crCR then val0EditExit(sender)
end;

procedure TOrphyGtsDlg.NonLineaireCBClick(Sender: TObject);
begin
  setEtalonnage
end;

procedure TOrphyGtsDlg.MasseFlottanteCBClick(Sender: TObject);
begin
    masseFlottante := MasseRG.itemIndex>0;
    modif := true;
    setMasse;
end;

procedure TOrphyGtsDlg.SetMasse;
const prise23 : array[boolean] of char = ('D','F');
var carac23 : char;
begin
   carac23 := prise23[voieCourante.avecAlim];
   if masseFlottante
      then begin
           if gain6CB.checked
              then begin
                 EntreeCB.Items[0] := 'EA0 15 V module';
                 EntreeCB.Items[1] := 'EA1 15 V module';
                 EntreeCB.Items[2] := 'EA2 15 V module';
                 EntreeCB.Items[3] := 'EA3 15 V module';
              end
              else begin
                 EntreeCB.Items[0] := 'EA0 2,5 V prise A';
                 EntreeCB.Items[1] := 'EA1 2,5 V prise A';
                 EntreeCB.Items[2] := 'EA2 2,5 V prise '+carac23;
                 EntreeCB.Items[3] := 'EA3 2,5 V prise '+carac23;
              end;
           EntreeCB.Items[4] := 'EA4 50 mV prise B';
           EntreeCB.Items[5] := 'EA5 50 mV prise B';
           EntreeCB.Items[6] := 'EA6 500 mV prise C';
           EntreeCB.Items[7] := 'EA7 1 V prise C';
      end
      else begin
           if gain6CB.checked
              then begin
                 EntreeCB.Items[0] := 'EA0 0-30 V module';
                 EntreeCB.Items[1] := 'EA1 0-30 V module';
                 EntreeCB.Items[2] := 'EA2 0-30 V module';
                 EntreeCB.Items[3] := 'EA3 0-30 V module';
              end
              else begin
                 EntreeCB.Items[0] := 'EA0 0-5 V prise A';
                 EntreeCB.Items[1] := 'EA1 0-5 V prise A';
                 EntreeCB.Items[2] := 'EA2 0-5 V prise '+carac23;
                 EntreeCB.Items[3] := 'EA3 0-5 V prise '+carac23;
              end;
           EntreeCB.Items[4] := 'EA4 0-100 mV prise B';
           EntreeCB.Items[5] := 'EA5 0-100 mV prise B';
           EntreeCB.Items[6] := 'EA6 0-1 V prise C';
           EntreeCB.Items[7] := 'EA7 0-2 V prise C';
     end;
     BevelZero.Visible := masseFlottante;
     EntreeCB.ItemIndex := voieCourante.numOrphy;
end;

procedure TOrphyGtsDlg.Gain6CBClick(Sender: TObject);
begin
   setMasse;
   voieCourante.gain6 := gain6CB.checked and (voieCourante.numOrphy<4);  
end;

end.

