unit GTSDDE;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DdeMan, registry, clipbrd,
  ComCtrls, oomisc, math, shellApi,
  Maths, Graphe, uniteker, gtsutil, gtsdef;

type
  Tenvoi = (eAdd,eLoad,ePlus);
  TFormDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    procedure FormCreate(Sender: TObject);
    procedure ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
  private
      procedure AjouteConst(var donnees : TstringList);
      procedure MajRegressi;
  public
      procedure Execute(Ordre : Tenvoi);
      procedure EnvoieDonnees(avecDDE : boolean);
      procedure SauveDonnees(NomFichier : string);
  end;

var
  FormDDE: TFormDDE;

implementation

uses gtsMain, gtsconst;

const crTab=#9;

{$R *.DFM}

procedure TFormDDE.AjouteConst(var Donnees : TstringList);
begin with gtsMainForm do
     if (NomConstante<>'') and
        not isnan(valeurConstante) then begin
     donnees.Add('');
     donnees.Add(unicodeVersRw3(nomConstante));
     donnees.Add(unicodeVersRw3(uniteConstante));
     donnees.Add(FloatToStrPoint(valeurConstante));
end end;

procedure TFormDDE.Execute(Ordre : Tenvoi);

Procedure lanceRegressi;
var hSemaphore : integer;
begin
   hSemaphore := CreateSemaphore(nil,0,1,'Regressi');
   if (hSemaphore<>0) and
      (GetLastError = Error_Already_Exists) then exit;
   if ShellExecute(0, 'open', Pchar(ClientDde.ServiceApplication), nil, nil, SW_SHOWDEFAULT) >= 32 then sleep(2000);
end;

procedure Lance;
begin
    case ordre of
         eAdd : if not ClientDDE.ExecuteMacro('CLIP|ADD', false) then
            ShowMessage('Transfert non excut');
         eLoad : if not ClientDDE.ExecuteMacro('CLIP|LOAD', false) then
            ShowMessage('Transfert non excut');
         ePlus : if not ClientDDE.ExecuteMacro('CLIP|PLUS', false) then
            ShowMessage('Transfert non excut');
    end;
    ClientDDE.CloseLink;
end;

begin
     LanceRegressi;
     ClientDDE.SetLink('Regressi','ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
        then Lance
        else begin
             sleep(1000);
             if ClientDDE.OpenLink
                then Lance
                else ShowMessage('Impossible de lancer Regressi');
        end;
end;

procedure TFormDDE.MajRegressi;
var Ini : TRegIniFile;
begin
    Ini := TRegIniFile.create('Software');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','');
    Ini.Free;
    Ini := TRegIniFile.create('Software\Regressi');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path',ClientDDE.ServiceApplication);
    Ini.Free;
    if ClientDDE.ServiceApplication='' then
       ClientDDE.ServiceApplication := 'regressi.exe';
end;

procedure TFormDDE.FormCreate(Sender: TObject);
begin
    MajRegressi
end;

procedure TFormDDE.EnvoieDonnees(avecDDE : boolean);
var i : integer;
    v,v1 : indiceVoie;
    ligne : string;
    ligneOK : boolean;
    Donnees : TstringList;
begin with grapheGts do begin { EnvoieDonnees }
     Screen.Cursor := crHourGlass;
     Donnees := TstringList.create;
     case modeAcq of
          AcqTemps : v1 := voieT;
          AcqPoint : begin
                v1 := voieT;
                for i := 0 to maxVecteur do
                   voieOrphy[voieT].vecteurAff[i] := i;
             end;
          AcqClavier : v1 := voieClavier;
          else v1 := voieT;
     end;
     if avecDDE then donnees.Add(Application.exeName);
     if avecDDE and (ConstanteDlg.NewPageCB.itemIndex=1)
          then donnees.Add('')
          else donnees.Add('Acquisition par Orphy GTS');
     donnees.Add(GtsMainForm.Commentaire);
     if (modeAcq=AcqPoint)
         then Ligne := 'num' + crTab
         else Ligne := unicodeVersRw3(voieOrphy[v1].nom) + crTab;
     for v := voieT to voieMax do with voieOrphy[v] do
         if active and (v<>v1) then
            ligne := ligne +  unicodeVersRw3(nom) + crTab;
     donnees.Add(ligne);
     if (modeAcq=AcqPoint)
         then Ligne := '' + crTab
         else Ligne := unicodeVersRw3(voieOrphy[v1].nomUnite) + crTab;
     for v := voieT to voieMax do with voieOrphy[v] do
         if active and (v<>v1) then
            ligne := ligne + unicodeVersRw3(nomUnite) + crTab;
     donnees.Add(ligne);
     if (modeAcq=AcqPoint) 
         then Ligne := '' + crTab
         else Ligne := unicodeVersRw3(voieOrphy[v1].signif) + crTab;
     for v := voieT to voieMax do with voieOrphy[v] do
         if active and (v<>v1) then
            ligne := ligne + unicodeVersRw3(signif) + crTab;
     donnees.Add(ligne);
     for i := 0 to pred(NbreAff) do begin
         ligneOK := true;
         for v := voieT to voieMax do with voieOrphy[v] do
             if active and isnan(vecteurAff[i]) then
                ligneOK := false;
         if not LigneOK then continue;
         ligne := FloatToStrPoint(voieOrphy[v1].vecteurAff[i]) + crTab;
         for v := voieT to voieMax do
             if voieOrphy[v].active and (v<>v1) then
                ligne := ligne + FloatToStrPoint(voieOrphy[v].vecteurAff[i]) + crTab;
         donnees.Add(ligne);
     end;
     if avecDDE then begin
        AjouteConst(donnees);
        donnees.Add(symbReg2+intToStr(NbreCourbe)+' NOMX');
        for i := 1 to NbreCourbe do
            donnees.Add(unicodeVersRw3(voieOrphy[voieAbscisse].nom));
        donnees.Add(symbReg2+intToStr(NbreCourbe)+' NOMY');
        for v := succ(voieT) to voieMax do with voieOrphy[v] do
            if active and (v<>voieAbscisse) then
                 donnees.Add(unicodeVersRw3(nom));
        donnees.Add(symbReg2+intToStr(NbreCourbe)+' LIGNE');
        for v := succ(voieT) to voieMax do with voieOrphy[v] do
         if active and (v<>voieAbscisse) then
            if oTraceLigne
               then if oTracePoints
                  then donnees.Add('3') // ligne et point
                  else donnees.Add('2') // ligne
               else donnees.Add('1'); // point
     end;
     ClipBoard.AsText := Donnees.text;
     if avecDDE then if ConstanteDlg.NewPageCB.itemIndex = 1
           then Execute(eADD)
           else Execute(eLOAD);
     ConstanteDlg.NewPageCB.itemIndex := 1;
     Donnees.free;
     Screen.Cursor := crDefault;
end end; { EnvoieDonnees }

procedure TFormDDE.SauveDonnees(NomFichier : string);
var i : integer;
    v,v1 : indiceVoie;
    ligne : string;
    ligneOK : boolean;
    Donnees : TstringList;
begin with grapheGts do begin 
     Screen.Cursor := crHourGlass;
     Donnees := TstringList.create;
     case modeAcq of
          AcqTemps : v1 := voieT;
          AcqPoint : begin
                v1 := voieT;
                for i := 0 to maxVecteur do
                   voieOrphy[voieT].vecteurAff[i] := i;
             end;
          AcqClavier : v1 := voieClavier;
          else v1 := voieT;
     end;
     donnees.Add('Acquisition par Orphy GTS-2');
     donnees.Add(GtsMainForm.Commentaire);
     if (modeAcq=AcqPoint)
         then Ligne := 'num' + crTab
         else Ligne := unicodeVersRw3(voieOrphy[v1].nom) + crTab;
     for v := voieT to voieMax do with voieOrphy[v] do
         if active and (v<>v1) then
            ligne := ligne + unicodeVersRw3(nom) + crTab;
     donnees.Add(ligne);
     if (modeAcq=AcqPoint)
         then Ligne := '' + crTab
         else Ligne := unicodeVersRw3(voieOrphy[v1].nomUnite) + crTab;
     for v := voieT to voieMax do with voieOrphy[v] do
         if active and (v<>v1) then
            ligne := ligne + unicodeVersRw3(nomUnite) + crTab;
     donnees.Add(ligne);
     if (modeAcq=AcqPoint) 
         then Ligne := '' + crTab
         else Ligne := unicodeVersRw3(voieOrphy[v1].signif) + crTab;
     for v := voieT to voieMax do with voieOrphy[v] do
         if active and (v<>v1) then
            ligne := ligne + unicodeVersRw3(signif) + crTab;
     donnees.Add(ligne);
     for i := 0 to pred(NbreAff) do begin
         ligneOK := true;
         for v := voieT to voieMax do with voieOrphy[v] do
             if active and isnan(vecteurAff[i]) then
                ligneOK := false;
         if not LigneOK then continue;
         ligne := FloatToStrPoint(voieOrphy[v1].vecteurAff[i]) + crTab;
         for v := voieT to voieMax do
             if voieOrphy[v].active and (v<>v1) then
                ligne := ligne + FloatToStrPoint(voieOrphy[v].vecteurAff[i]) + crTab;
         donnees.Add(ligne);
     end;
     Donnees.SaveToFile(nomFichier);
     Donnees.free;
     Screen.Cursor := crDefault;
end end; { SauveDonnees }

procedure TFormDDE.ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
var Fonction : string;
    ArgStart : integer;
begin
     if (Msg.Count = 1) then begin
       try
       ArgStart := Pos('(',Msg[0]);
       if ArgStart>0
          then Fonction := Copy(Msg[0], 1, Pred(ArgStart))
          else Fonction := Msg[0];
       if (CompareText('CONFIG|LOAD',Fonction) = 0) or
          (CompareText('FILE|LOAD',Fonction) = 0) then begin
           GtsMainForm.setFocus;
           exit
       end;
       if (CompareText('CONFIG|SAVE',Fonction) = 0) or
          (CompareText('FILE|SAVE',Fonction) = 0) then begin
           exit
       end;
       if CompareText('FOCUS',Fonction) = 0 then begin
           GtsMainForm.setFocus;
           exit;
       end;
       if CompareText('GETDATA',Fonction) = 0 then begin
           ConstanteDlg.NewPageCB.itemIndex := 1;
           GtsMainForm.setFocus;
           exit;
       end;
       except
       end;
     end;
end;

end.
