unit GTSMAIN;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, Registry,
  ComCtrls, ToolWin, ImgList, LnsWin32, math,
  AdPort, oomisc, awuser, spin, clipBrd, inifiles,
  gtsUtil, uniteker, gtsdef, maths, graphe,
  gtsdde, constGts, FloatEdit, about, HiresTmr, XPMan;

const
     WM_File_Load = WM_USER + 2;

type
  TGTSmainForm = class(TForm)
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Timer: TTimer;
    PanelCourbe: TPanel;
    Oscillo: TPaintBox;
    OrphyAbsent: TPanel;
    Label6: TLabel;
    ComBtn: TSpeedButton;
    Header: TStatusBar;
    EscapeBtn: TSpeedButton;
    Menu: TPopupMenu;
    AproposItem: TMenuItem;
    CapteursItem: TMenuItem;
    ImageList: TImageList;
    Label7: TLabel;
    PleinEcranItem: TMenuItem;
    VoltmetreItem: TMenuItem;
    XPManifest1: TXPManifest;
    VoieSerie: TApdComPort;
    SaveConfigItem: TMenuItem;
    OpenConfigItem: TMenuItem;
    ToolBar1: TToolBar;
    EnregistreBtn: TToolButton;
    StopBtn: TToolButton;
    ResetBtn: TToolButton;
    UndoBtn: TToolButton;
    RegSaveBtn: TToolButton;
    PlusBtn: TToolButton;
    ExitBtn: TToolButton;
    Gauge: TProgressBar;
    ToolButton1: TToolButton;
    PanelCommande: TPanel;
    PanelMode: TPanel;
    SynchroGB: TGroupBox;
    SynchroLabel: TLabel;
    MonocoupCB: TCheckBox;
    BalayageGB: TGroupBox;
    Label12: TLabel;
    Label14: TLabel;
    DeltatLabel: TLabel;
    FechLabel: TLabel;
    DureeEdit: TEdit;
    DureeSpin: TSpinButton;
    NbreEdit: TEdit;
    NbreSpin: TSpinButton;
    ModeGB: TGroupBox;
    ModeLabel: TLabel;
    PointGB: TGroupBox;
    PointAutoCB: TCheckBox;
    SortieAnaGB: TGroupBox;
    LabelSA: TLabel;
    ClavierGB: TGroupBox;
    Label10: TLabel;
    ClavierEdit: TEdit;
    PanelVoies: TPanel;
    GroupBox5: TGroupBox;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    GroupBox4: TGroupBox;
    Label5: TLabel;
    EntreeBinGB: TGroupBox;
    EbinLabel: TLabel;
    GrapheVolt: TMenuItem;
    N1: TMenuItem;
    SaveData: TMenuItem;
    CopyData: TMenuItem;
    minmax: TLabel;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    ModeMagnumGB: TGroupBox;
    Label9: TLabel;
    MagnumAutoCB: TCheckBox;
    MagnumSE: TSpinEdit;
    Label8: TLabel;
    MasseLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure FileOpen(Sender: TObject);
    procedure FileSaveAs(Sender: TObject);
    procedure FileExit(Sender: TObject);
    procedure HelpAbout(Sender: TObject);
    procedure ModeItemClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure FormKeypress(Sender: TObject; var Key: Char);
    procedure OscilloPaint(Sender: TObject);
    procedure NombreDownClick(Sender: TObject);
    procedure NombreUpClick(Sender: TObject);
    procedure DureeSpinDownClick(Sender: TObject);
    procedure DureeSpinUpClick(Sender: TObject);
    procedure VoieAnaClick(Sender: TObject);
    procedure ClavierGBClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RegSaveBtnClick(Sender: TObject);
    procedure UndoBtnClick(Sender: TObject);
    procedure TriggerAvail(CP: TObject; Count: Word);
    procedure SortieAnaGBClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure ClavierEditKeyPress(Sender: TObject; var Key: Char);
    procedure CapteursItemClick(Sender: TObject);
    procedure ComBtnClick(Sender: TObject);
    procedure PointAutoCBClick(Sender: TObject);
    procedure EscapeBtnClick(Sender: TObject);
    procedure DureeEditKeyPress(Sender: TObject; var Key: Char);
    procedure NbreEditKeyPress(Sender: TObject; var Key: Char);
    procedure DureeEditExit(Sender: TObject);
    procedure NbreEditExit(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EntreeBinGBClick(Sender: TObject);
    procedure MonocoupCBClick(Sender: TObject);
    procedure WMFClick(Sender: TObject);
    procedure PlusBtnClick(Sender: TObject);
    procedure EFRGClick(Sender: TObject);
    procedure SynchroGBClick(Sender: TObject);
    procedure OscilloMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OscilloMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure OscilloMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PleinEcranClick(Sender: TObject);
    procedure Splitter1Moved(Sender: TObject);
    procedure CopyDataClick(Sender: TObject);
    procedure SaveDataClick(Sender: TObject);
    procedure GroupBox3Click(Sender: TObject);
    procedure MagnumAutoCBClick(Sender: TObject);
    private
      etatAcq : TetatAcq;
      utilMagnumCharge : boolean;
      FThreadSeuil : Thandle;
      OrdreProgramme,ordreLance : ansiString;
      OrphyPresent : boolean;
      PremiereAcquisition : boolean;
      premiereFois : boolean;
      indexResul : integer;
      debutLecture,finLecture : integer;
      TableauOrphy : array[byte] of byte;
      chaineRecue : ansiString;
      monocoup,relancerXresul : boolean;
      ReactiverGTS : boolean;
      CurseurSeuil : boolean;

    procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
    Procedure SetLectureParametres;
    Procedure MarquePointCourant;
    Procedure EffacePointCourant;
    procedure AfficheSynchro;
    procedure InitAttente;
    Procedure ChargeMagnum;
    Procedure LanceAcqMagnum;
    procedure LitPointAttente;
    Procedure EnregistrePointCourant;
    Procedure LanceAcqTemps;
    Procedure LanceAcqSA;
    procedure RegleTimer;
    Procedure testOrphy;
    Procedure SetBoutons;
    Procedure MajTemps;
    Procedure SetDuree;
    procedure affecteSeuil(y : integer);
    Function Duree125(duree : double) : double;
    Procedure AjusteDeltat;
    Procedure setNombre;
    Procedure SetSizeVoie;
    Procedure NbreAffNul;
    procedure LanceAttenteSeuil;
    procedure LanceAttenteBouge;
    procedure stopAttenteSeuil;
    procedure TriggerAvailMagnum(CP: TObject; Count: Word);
    public
      NumCom : integer;
      nomConstante : string;
      uniteConstante : string;
      commentaire : string;
      valeurConstante : double;
      CfgGTSPath : String;
      DebutAcquisition : TdateTime;
      avecTrace : boolean;
      procedure ecritOrphy(ordre : ansiString);
      Function getByte(commande : byte) : byte;
      Function getWord(commande : ansiString) : word;
      Function getString : ansiString;
      procedure LitConfig(NomFichier : String);
      procedure EcritConfig(nomFichier : String);
      procedure AfficheReglage;
      procedure LitCanVecteur;
      procedure Xresul;
      procedure stopMagnum;
   protected
      procedure WMFileLoad(var Msg : TMessage); message WM_File_Load;
      procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo); message wm_GetMinMaxInfo;
      procedure WMSetFocus(var Msg: Tmessage); message wm_SetFocus;
   end;

var
  GTSmainForm: TGTSmainForm;

implementation

uses Modedlg, GTSCFG, Clavier, GTSCONST, Sadlg, Choixcap,
     Ebin, Synchro, SysInfoCtrls, MagnumDlg, MagnumStop;

var ArretSeuil : boolean;
    CharSynchro : ansiChar;
    VoieSerieSeuil : TapdComPort;

{$R *.DFM}

function AttenteSeuil : integer;stdcall;
type Tetat = (lecture,attenteBas,attenteHaut);
const imax = 5;
var mesure,i : byte;
    etat : Tetat;
begin with grapheGts do begin
      etat := attenteBas;
      arretSeuil := false;
      repeat
         VoieSerieSeuil.flushInBuffer;
         VoieSerieSeuil.OutPut := charSynchro;
         i := 0;
         repeat
             sleep(2);
             inc(i);
             voieSerieSeuil.processCommunications;
         until voieSerieSeuil.CharReady or (i=imax); // 10 ms 
         if voieSerieSeuil.CharReady then begin
            mesure := ord(voieSerieSeuil.getChar);
            case Etat of
             attenteBas : if synchroUp
                 then if mesure>SeuilSynchro
                    then etat := attenteHaut
                    else
                 else if mesure<SeuilSynchro
                    then etat := attenteHaut
                    else ;{ attenteBas }
             attenteHaut : if synchroUp
                  then if mesure<=SeuilSynchro
                      then etat := lecture
                      else
                  else if mesure>=SeuilSynchro
                      then etat := lecture
                      else ; { attenteHaut }
          end; { case }
          if etat<>lecture then with grapheGTS.voieOrphy[grapheGTS.voieSynchro] do begin
             valeurCourante := valeurReal(mesure);
             valeurAff := valeurCourante;
             LabelVoie.caption := AffVoltmetre;
          end;
          end;
     until (etat=lecture) or arretSeuil;
     if etat=lecture then GTSMainForm.LanceAcqTemps;
     result := 0
end end;

function AttenteBouge : integer;stdcall;
type Tetat = (lecture,attente);
const imax = 5;
var mesure,oldMesure,i : byte;
    etat : Tetat;
begin with grapheGts do begin
      etat := attente;
      arretSeuil := false;
      oldMesure := 0;
      repeat
         VoieSerieSeuil.flushInBuffer;
         VoieSerieSeuil.OutPut := charSynchro;
         i := 0;
         repeat
             delayS(0.002);
             inc(i);
             voieSerieSeuil.processCommunications;
         until voieSerieSeuil.CharReady or (i=imax); { 10 ms }
         if voieSerieSeuil.CharReady then begin
            mesure := ord(voieSerieSeuil.getChar);
            if oldMesure=0
               then oldMesure := mesure
               else if (abs(mesure-oldMesure)>deltaBouge)
                    then etat := lecture
        end;
     until (etat=lecture) or arretSeuil;
     if etat=lecture then GTSMainForm.LanceAcqTemps;
     result := 0
end end;

function IsPortAvailable(ComNum : Cardinal) : Boolean;

  function MakeComName(const Dest : PChar; const ComNum : Cardinal) : PChar;
    {-Return a string like 'COMXX'}
  begin
    StrFmt(Dest,'\\.\COM%d',[ComNum]);
    MakeComName := Dest;
  end;

var
  ComName : array[0..12] of Char;
  Res : Integer;
  DeviceLayer : TApdBaseDispatcher;
begin
  DeviceLayer  := TApdWin32Dispatcher.Create(nil);
  try
    if (ComNum = 0)
    then Result := False
    else begin
      Res := DeviceLayer.OpenCom(MakeComName(ComName,ComNum), 64, 64);
      if (Res < 0) and (GetLastError <> DWORD(Abs(ecAccessDenied)))
        then Result := False
        else begin
          Result := True;
          DeviceLayer.CloseCom;
        end;
    end;
  finally
    DeviceLayer.Free;
  end;
end;

procedure TGTSmainForm.AppMessage(var Msg: TMsg; var Handled: Boolean);

function NonCouperCopier : boolean;
var EditCtrl : TcustomEdit;
begin
   NonCouperCopier := true;
   if ( (msg.Wparam=24) or (msg.Wparam=3) or (msg.Wparam=26)) and
      (Screen.ActiveControl is TCustomEdit)
      then begin
          EditCtrl := Screen.ActiveControl as TCustomEdit;
          if EditCtrl.SelLength > 0 then begin
             case msg.Wparam of
                 24 : EditCtrl.CutToClipBoard;
                 3 : EditCtrl.CopyToClipBoard;
                 26 : ; { Undo }
             end;
             Handled := true;
             NonCouperCopier := false;
          end;
   end;
end;

const
         GrecMaj : array[1..26] of char =
  ('A','B','C',deltaMaj,'E',phiMaj,gammaMaj,'H',iotaMaj,psiMaj,'K',lambdaMaj,
   'M','N','O',piMaj,thetaMaj,'R',sigmaMaj,'T','U','V',omegaMaj,xiMaj,'Y','Z');

        GrecMin : array[1..26] of char =
  (alpha,beta,chi,delta,epsilon,phi,gamma,eta,iota,psi,'k',lambda,
   mu,nu,'o',piMin,theta,rho,sigma,tau,'u','v',omega,xi,'y',zeta);

begin with Msg do
     if Message=wm_char then begin
            if (Wparam>0) and (Wparam<=26) then
             if (GetKeyState(vk_control)<0) then
                 if (GetKeyState(vk_shift)<0) or
                    (GetKeyState(vk_capital)<0)
                    then Wparam := ord(GrecMaj[Wparam])
                    else if (Wparam<>22) and NonCouperCopier
                      { Edition Windows copier coller couper }
                         then Wparam := ord(GrecMin[Wparam]);
    end;
end;

procedure TGTSmainForm.LitConfig(NomFichier : String);
var Fichier : tMemIniFile;
    voie : indiceVoie;
begin
     nomFichier := changeFileExt(nomFichier,'.GTS');
     if not FileExists(nomFichier) then exit;
     Fichier := tMemIniFile.create(NomFichier);
     with Fichier,grapheGTS do begin
       nomConstante := readString('Constante','Nom','');
       uniteConstante := readString('Constante','Unite','');
       commentaire := readString('Constante','Commm','');
       voieAbscisse := ReadInteger('Affichage','Abscisse',voieA);
       oTraceLigne := ReadBool('Affichage','Ligne',true);
       oTracePoints := ReadBool('Affichage','Points',false);
       quadrillage := ReadBool('Affichage','Grille',false);
       AnalyseurLogique := ReadBool('Affichage','AnalLog',false);
       modeAcq := TmodeAcq(readInteger('Acquisition','Mode',1));
       debutAcquisition := readDateTime('Balayage','DebutAcq',now);
       BaseDeTemps.Maxi :=  ReadFloat('Balayage','Dure',1.0);
       NbreInter := readInteger('Balayage','Nombre',128);
       BaseDeTemps.Deltat := BaseDeTemps.Maxi/NbreInter;
       Monocoup := ReadBool('Synchro','Monocoup',true);
       PointAutoCB.checked := ReadBool('Point','Auto',true);
       AvecUnAxe := ReadBool('Affichage','AxeY',true);
       frontSynchro := ReadInteger('Synchro','Front',0);
       seuilSynchro := ReadInteger('Synchro','Seuil',127);
       deltaBouge := ReadInteger('Synchro','Bouge',3);       
       voieSynchro := ReadInteger('Synchro','Voie',voieA);
       if voieSynchro<voieA then voieSynchro := voieA;
       if voieSynchro>voieAnaMax then voieSynchro := voieA;
       masseFlottante := ReadBool('Acquisition','Masse',true);
       modeSynchro := TModeSynchro(readInteger('Synchro','Mode',0));
       dimPoint := fichier.readInteger('Affichage','DimPoint',dimPoint);
       sortieAnalogique.load('SA',fichier);
       magnum.load('Magnum',fichier);
       entreeBinaire.load('EB',fichier);
       entreeClavier.load('Clavier',fichier);
       for voie := voieA to VoieAnaMax do
           voieOrphy[voie].load('V'+IntToStr(voie-voieA+1),fichier);
    end;
    AjusteDeltat;
    fichier.free;
    NbreAffNul;
end;{litConfig}

Procedure TGTSmainForm.EcritConfig(nomFichier : String);
var Fichier : tMemIniFile;

Procedure SauveBloc;
var voie : indiceVoie;
begin with fichier,grapheGTS do begin
       WriteString('Constante','Nom',nomConstante);
       WriteString('Constante','Comm',Commentaire);
       WriteString('Constante','Unit',UniteConstante);
       WriteInteger('Affichage','Abscisse',voieAbscisse);
       WriteBool('Affichage','Ligne',oTraceLigne);
       WriteBool('Affichage','Points',oTracePoints);
       WriteInteger('Acquisition','Mode',ord(modeAcq));
       WriteFloat('Balayage','Dure',BaseDeTemps.Maxi);
       WriteInteger('Balayage','Nombre',NbreInter);
       writeDateTime('Balayage','DebutAcq',debutAcquisition);
       WriteBool('Synchro','Monocoup',monocoup);
       WriteBool('Affichage','AxeY',avecUnAxe);
       WriteBool('Affichage','Grille',quadrillage);
       WriteBool('Affichage','AnalLog',AnalyseurLogique);
       WriteInteger('Affichage','DimPoint',dimPoint);
       WriteBool('Point','Auto',pointAutoCB.checked);
       WriteBool('Acquisition','Masse',masseFlottante);       
       WriteInteger('Synchro','Mode',ord(modeSynchro));
       WriteInteger('Synchro','Front',frontSynchro);
       WriteInteger('Synchro','Seuil',seuilSynchro);
       WriteInteger('Synchro','Bouge',deltaBouge);       
       WriteInteger('Synchro','Voie',voieSynchro);
       entreeBinaire.store('EB',fichier);
       magnum.store('Magnum',fichier);       
       sortieAnalogique.store('SA',fichier);
       entreeClavier.store('Clavier',fichier);
       for voie := voieA to VoieAnaMax do
           voieOrphy[voie].store('V'+IntToStr(voie-voieA+1),fichier);
end end;

begin
   nomFichier := ChangeFileExt(nomFichier,'.GTS');
   try
   Fichier := tMemIniFile.create(nomFichier);
   SauveBloc;
   Fichier.UpdateFile;
   Fichier.free;
   except
   end;
end; { SauveConfig }

{$I Acqgts.pas}

procedure TGTSmainForm.FormCreate(Sender: TObject);

Procedure ValeurDefaut;
var FichierIni : TRegIniFile;
begin
       ResetBtn.Enabled := false;
       debutAcquisition := now;
       with grapheGTS do begin
          voieSynchro := voieA;
          seuilSynchro := 127;
          modeSynchro := s_clavier;
          NbreInter := 128;
       end;
       BaseDeTemps.Maxi := 1.0;
       BaseDeTemps.Deltat := BaseDeTemps.Maxi/GrapheGTS.NbreInter;
       nomConstante := '';
       uniteConstante := '';
       valeurConstante := Nan;
       commentaire := '';
       PremiereFois := true;
       orphyPresent := false;
       etatAcq := eaTerminee;
       CapteursItem.visible := existeOption('C',true);
       FichierIni := TRegIniFile.create(RegistreGTS);
       NumCom := FichierIni.readInteger('COM','Num',1);
       CfgGTSPath := FichierIni.readString('Config','Path',MesDocsDir);
       avecTrace := FichierIni.readBool('Config','Trace',false);
       saveDialog.initialDir := cfgGTSpath;
       OpenDialog.initialDir := CfgGTSPath;
       FichierIni.free;
end;

var i : integer;
    voie : indiceVoie;
begin
   Application.HelpFile := ChangeFileExt(application.ExeName,'.CHM');
   Application.OnHint := ShowHint;
   Application.OnMessage := AppMessage;
   grapheGts := TgrapheGts.create;
   grapheGts.canvas := oscillo.canvas;
   oscillo.canvas.font.name := 'Calibri';
   ValeurDefaut;
   with PanelVoies do
     for i := 0 to pred(controlCount) do
         if controls[i] is TgroupBox then begin
         voie := TGroupBox(controls[i]).tag;
         with grapheGTS.voieOrphy[voie] do begin
            GBvoie := TgroupBox(controls[i]);
            LabelVoie := Tlabel(TgroupBox(controls[i]).controls[0]);
         end;
     end;
   with grapheGTS.voieOrphy[voieSA] do begin
      GBvoie := sortieAnaGB;
      LabelVoie := LabelSA;
   end;
   with grapheGTS.voieOrphy[voieClavier] do begin
      GBvoie := ClavierGB;
   end;
end;

procedure TGTSmainForm.ShowHint(Sender: TObject);
begin
   if Application.Hint=''
      then Caption := trAcqGTS
      else Caption := Application.Hint
end;

procedure TGTSmainForm.FileOpen(Sender: TObject);
begin
    SetLectureParametres;
    if OpenDialog.Execute then
       litConfig(OpenDialog.FileName);
    afficheReglage;
end;

procedure TGTSmainForm.FileSaveAs(Sender: TObject);
var sauveTimer : boolean;
begin
  sauveTimer := timer.enabled;
  timer.enabled := false;
  SaveDialog.filter := 'Configuration GTS|*.GTS';
  if SaveDialog.Execute then
     ecritConfig(SaveDialog.FileName);
  timer.enabled := sauveTimer;
end;

procedure TGTSmainForm.FileExit(Sender: TObject);
begin
   Close
end;

procedure TGTSmainForm.HelpAbout(Sender: TObject);
begin
     AboutBox := TAboutBox.create(self);
     AboutBox.ShowModal;
     AboutBox.free;
end;

procedure TGTSmainForm.ecritOrphy(ordre : ansiString);
begin
    if orphyPresent then VoieSerie.OutPut := ordre+crCR
end;

Procedure TGTSmainForm.SetLectureParametres;
var voie : indiceVoie;
begin
     Timer.enabled := false;
     if (grapheGts.modeAcq=AcqTemps) and
        (etatAcq=eaAttenteResul) and
        OrphyPresent then begin
        repeat
           VoieSerie.flushInBuffer;
           delayTicks(2,false);
           Application.processMessages;
           { vide buffer des messages RS232 Windows }
        until not VoieSerie.charReady;
        etatAcq := eaTerminee;
     end;
     for voie := succ(voieClavier) to VoieMax do
         grapheGts.voieOrphy[voie].LabelVoie.caption := '';
end;

Function tGTSmainForm.getByte(commande : byte) : byte;
var ET : eventTimer;
begin
    result := 0;
    if not orphyPresent then exit;
    VoieSerie.flushInBuffer;
    VoieSerie.OutPut := ansichar(commande);
    newTimer(ET,3);
    repeat
          voieSerie.processCommunications
    until VoieSerie.CharReady or timerExpired(ET);
    if VoieSerie.CharReady then result := ord(voieSerie.getChar);
end;

Function tGTSmainForm.getWord(commande : ansiString) : word;
var ET : eventTimer;
    chaine : ansiString;
    carac : ansichar;
begin
    result := 0;
    if not orphyPresent then exit;
    VoieSerie.flushInBuffer;
    VoieSerie.OutPut := commande+crCR;
    chaine := '';
    carac := #0;
    newTimer(ET,5);
    repeat
          if voieSerie.CharReady
             then begin
                carac := voieSerie.getChar;
                if carac>' ' then chaine := chaine+carac;
             end
             else voieSerie.processCommunications;
    until (carac=crCR) or timerExpired(ET);
    try
    result := strToInt(chaine);
    except
    result := 0;
    end;
end;

Procedure tGTSmainForm.MarquePointCourant;
var voie : indiceVoie;
begin with grapheGts do begin
   for voie := succ(voieClavier) to VoieMax do with voieOrphy[voie] do
       if active then LabelVoie.caption := AffVoltmetre; 
   if ReticuleTrace then exit;       
   with oscillo.canvas.pen do begin
       mode := pmNotXor;
       width := 3;
       style := psSolid;
   end;
   for voie := succ(voieT) to VoieMax do with voieOrphy[voie] do
       if active and (voie<>voieAbscisse) then traceReticule(voie);
   with oscillo.canvas.pen do begin
        mode := pmCopy;
        width := 1;
   end;
   ReticuleTrace := true;   
end end;

Procedure tGTSmainForm.EffacePointCourant;
var voie : indiceVoie;
begin with grapheGts do begin
   if not ReticuleTrace then exit;
   with oscillo.canvas.pen do begin
       mode := pmNotXor;
       width := 3;
       style := psSolid;
   end;
   for voie := succ(voieT) to VoieMax do with voieOrphy[voie] do
       if active and (voie<>voieAbscisse) then
             traceReticule(voie);
   with oscillo.canvas.pen do begin
        mode := pmCopy;
        width := 1;
   end;
   ReticuleTrace := false;
end end;

procedure tGTSmainForm.AfficheSynchro;
var i : integer;
begin with grapheGts do begin
   with BaseDeTemps do
        for i := 0 to MaxVecteur do
            vecteurAff[i] := deltat*i; { seconde }
  if ModeAcq=AcqTemps then begin
     if modeSynchro=s_relaxe then monocoup := false;
     if modeSynchro=s_clavier then monocoup := true;
     if modeSynchro=S_front
        then ordreLance := 'XSEAP '+char(frontSynchro+ord('0'))
        else ordreLance := 'XEAP';
  end;
end end; // afficheSynchro

procedure tGTSmainForm.AfficheReglage;

procedure AfficheVoieX;
const StrDelta : array[boolean] of String = ('0.5','1');
begin with grapheGts do begin
   MonocoupCB.checked := Monocoup;
   BalayageGB.visible := modeAcq in [AcqTemps];
   SortieAnaGB.visible := modeAcq=AcqSortieAna;
   SortieAnalogique.active := modeAcq=AcqSortieAna;
   PointGB.visible := modeAcq=AcqPoint;
   EntreeBinaire.active := EntreeBinaire.active and
                           (modeAcq=AcqPoint);
   EntreeBinGB.visible := modeAcq=AcqPoint;
   SynchroGB.visible := modeAcq=AcqTemps;
   entreeClavier.active := modeAcq=AcqClavier;
   ClavierGB.visible := modeAcq=AcqClavier;
   ModeLabel.caption := nomModeAcq[ModeAcq];
   SynchroLabel.caption := nomModeSynchro[ModeSynchro];
   ModeMAgnumGB.Visible := modeAcq=AcqMagnum;
   if not oTraceLigne and not oTracePoints then begin
         oTraceLigne := false;
         oTracePoints := true;
   end;
   case modeAcq of
        AcqTemps : begin
           NbreInter := NbreInter; { force les vrifications }
           RegleTimer;
           DureeEdit.text := chaineDuree(BaseDeTemps.Maxi);
           NbreEdit.text := IntToStr(NbreInter);
           DeltatLabel.caption := 't='+chaineDuree(BaseDeTemps.deltat);
           FechLabel.caption := 'Fech='+Frequence.formatUnite(1/BaseDeTemps.deltat);
           minmax.visible := false;
           if BaseDeTemps.freqMin then begin
              minmax.visible := true;
              minmax.caption := 'Mini';
           end;
           if BaseDeTemps.freqMax then begin
              minmax.visible := true;
              minmax.caption := 'Maxi';
           end;
           Gauge.position := 0;
           Gauge.Max := NbreInter;
           if BaseDeTemps.deltat<0.25
              then Timer.interval := MajTimerTemps
              else Timer.interval := round(1000*baseDeTemps.deltat);
           NbreSpin.visible := true;
           NbreEdit.enabled := true;
       end;
       AcqMagnum : begin
           Gauge.position := 0;
           Gauge.Max := 1024;
           Timer.interval := MajTimerMagnum;
           ChargeMagnum;
       end;
       AcqPoint,AcqClavier : Timer.interval := MajTimerAttente;
       AcqSortieAna : with sortieAnalogique do
            NbreInter := finSortie-debutSortie+1;
   end;
   Gauge.visible := modeAcq in [AcqTemps,AcqMagnum];
end end;{ afficheVoieX }

Procedure AfficheStatus;
var voie : indiceVoie;
begin
   with entreeClavier do
        ClavierGB.caption := nom+'=clavier';
   with SortieAnalogique do
        SortieAnaGB.caption := nom+'='+nomVoieOrphy+' '+calibreVoie;
   with EntreeBinaire do if active
        then EntreeBinGB.caption := Nom+'=EB0..EB'+IntToStr(NbreEB-1)
        else EntreeBinGB.caption := trEntreeBin;
   for voie := succ(voieClavier) to voieMax do
       grapheGTS.voieOrphy[voie].LabelVoie.caption := '';
   for voie:=voieA to VoieAnaMax do with grapheGTS.voieOrphy[voie] do
       GBvoie.caption := nom+'='+nomVoieOrphy+' '+calibreVoie;
   SetSizeVoie;
end;

var voie : indiceVoie;
begin with grapheGTS do begin // afficheReglage
   MasseLabel.caption := nomMasse[masseFlottante];
   BaseDeTemps.active := modeAcq=AcqTemps;
   if voieAbscisse>voieMax then voieAbscisse := voieA;
   voieOrphy[voieMagnum].active := modeAcq=AcqMagnum;
   case modeAcq of
        AcqPoint : if voieAbscisse in [voieT,voieSA,voieClavier]
              then voieAbscisse := voieA;
        AcqSortieAna : voieAbscisse := voieSA;
        AcqMagnum : begin
           voieAbscisse := voieT;
           for voie := voieT to voieAnaMax do voieOrphy[voie].active := false;
           voieOrphy[voieT].active := true;
           voieOrphy[voieMagnum].active := true;
           voieOrphy[voieT].mini := 0;
           voieOrphy[voieT].maxi := 1;
        end;
        AcqClavier : if voieAbscisse in [voieT,voieSA] then
              voieAbscisse := voieClavier;
        AcqTemps : begin
            if voieAbscisse in [voieClavier,voieSA] then
               voieAbscisse := voieT;
        end;
   end;
   if not voieOrphy[voieAbscisse].active then
      if OKreg(okActiveAbscisse+voieOrphy[voieAbscisse].nom)
         then voieOrphy[voieAbscisse].active := true
         else begin
            for voie := voieT to voieMax do
               if voieOrphy[voie].active then begin
                  voieAbscisse := voie;
                  break
               end;
            if not voieOrphy[voieAbscisse].active then begin
               voieOrphy[voieT].active := true;
               voieAbscisse := voieT;
            end;
         end;
   NbreVoie := 0;
   NbreCourbe := 0;
   for voie := succ(voieT) to voieMax do
       if voieOrphy[voie].active then begin
            if voie<>voieAbscisse then inc(NbreCourbe);
            if (voie>=voieA) and (voieA<=voieAnaMax) then inc(NbreVoie);
       end;
   if (modeAcq=AcqTemps) and
      (NbreCourbe=0) and
      (NbreVoie=1) then begin
         voieAbscisse := voieT;
         NbreCourbe := 1;
   end;
   if NbreCourbe=0 then begin
      if voieA=voieAbscisse
         then voieOrphy[succ(voieA)].active := true
         else voieOrphy[voieA].active := true;
      NbreCourbe := 1;
      inc(NbreVoie);
   end;
   AfficheVoieX;
   AfficheStatus;
   AfficheSynchro;
   if (BaseDeTemps.Maxi>20) and
      (modeAcq=AcqTemps) and
      not(monocoup) then begin
         afficheErreur(erMonocoup);
         monocoup := true;
         monocoupCB.checked := true;
   end;
   VoieSerie.onTriggerAvail := nil;
   stopAttenteSeuil;
   if resetBtn.enabled
      then resetBtnClick(nil)
      else initAttente;
end end; // afficheReglage

procedure tGTSmainForm.InitAttente;
var debutLoc : integer;
begin with grapheGTS do begin
   PremiereAcquisition := true;
   case modeAcq of
         AcqClavier : with entreeClavier do begin
             Header.Panels[0].text := hClavier;
             effacePointCourant;
                        GBvoie.color := clWhite;
//                        LabelVoie.font.color := couleur;
                        GBvoie.font.color := couleur;
             valeurCourante := Mini;
             valeurAff := mini;
             marquePointCourant;
             ClavierEdit.text := '';
             ClavierEdit.setFocus;
         end;
         AcqMagnum : with voieOrphy[voieMagnum] do begin
             Header.Panels[0].text := hMagnum;
             effacePointCourant;
             valeurCourante := 0;
             mini := 0;
             maxi := 0.2;
             valeurAff := mini;
         end;
         AcqPoint : if PointAutoCB.checked
                then Header.Panels[0].text := hPointAuto
                else Header.Panels[0].text := hPoint;
         AcqTemps : case modeSynchro of
            s_clavier : begin
               Header.Panels[0].text := hSynchroClavier;
               etatAcq := eaAttenteSynchro;
            end;
            s_seuil : begin
               Header.Panels[0].text := hSynchroSeuil;
               etatAcq := eaAttenteSynchro;
               LanceAttenteSeuil;
            end;
            s_bouge : begin
               Header.Panels[0].text := hSynchroBouge;
               etatAcq := eaAttenteSynchro;
               LanceAttenteBouge;
            end;
            else lanceAcqTemps;
         end;
         AcqSortieAna : with sortieAnalogique do begin
               etatAcq := eaAttenteSynchro;
                       GBvoie.color := clWhite;
                       LabelVoie.font.color := couleur;
                       GBvoie.font.color := couleur;
               effacePointCourant;
               if inverse
                  then debutLoc := finSortie
                  else debutLoc := debutSortie;
               EcritOrphy('XSA '+intToStr(DebutLoc));
               valeurAff := valeurReal(DebutLoc);
               valeurCourante := valeurAff;
               marquePointCourant;
         end;
   end; // case
   timer.enabled := orphyPresent;
   setBoutons;
   Header.Panels[1].text := '';
   oscillo.refresh;
end end; // initAttente

procedure TGTSmainForm.ModeItemClick(Sender: TObject);
begin
    SetLectureParametres;
    if (ModeAcqDlg.showModal=mrOK) and
       ModeAcqDlg.Modif then NbreAffNul;
    AfficheReglage;
end;

procedure TGTSmainForm.FormActivate(Sender: TObject);
var Ini : tRegIniFile;
begin
     if premiereFois then begin
        TestOrphy;
        Ini := TregIniFile.create(RegistreGTS);
        WindowState := TwindowState(Ini.ReadInteger('Window','State',ord(wsNormal)));
        Ini.free;
     end;// premierefois
     premiereFois := false;
end;

Function TGTSmainForm.GetString : ansiString;
var ATimer : EventTimer;
    C : ansichar;
    chaineLue : ansiString;
begin
   newTimer(Atimer,18);
   C := #0;
   chaineLue := '';
   repeat
        if voieSerie.charReady
           then begin
              C := voieSerie.GetChar;
              if C>=' ' then ChaineLue := chaineLue+C;
           end
           else Application.processMessages;
   until (C=crCR) or timerExpired(Atimer);
   result := chaineLue;
end;

Procedure TGTSmainForm.TestOrphy;

Procedure setOrphyPresent;
var nomFichier : string;
    i : integer;
begin
   screen.cursor := crHourGlass;
   NumCom := voieSerie.ComNumber;
   ecritOrphy('XRESET');
   Header.Panels[0].text := trYesOrphy;
   if ParamCount>0 then begin
              NomFichier := ParamStr(1);
              for i := 2 to paramCount do
                  NomFichier := NomFichier+' '+ParamStr(i);
              if pos('\',NomFichier)=0 then
                  NomFichier := MesDocsDir+nomFichier;
              if not FileExists(nomFichier)
                  then NomFichier := MesDocsDir+'GTS';
              LitConfig(NomFichier);
    end;
    // else dfaut 
    afficheReglage;
    screen.cursor := crDefault;
end;

Procedure testCom(Numero : byte);
var posOrphy : integer;
    chaineLue : ansiString;
begin                                                
   {$IFDEF DEBUG}
   VoieSerie.TraceName := 'GTS'+intTostr(numero)+'.trc';
   VoieSerie.LogName := 'GTS'+intTostr(numero)+'.log';
   VoieSerie.Tracing := tlOn;
   VoieSerie.Logging := tlOn;
   {$Endif}
   try
   VoieSerie.comNumber := Numero;
   VoieSerie.Baud := 9600;
   VoieSerie.Open := true;
   except
      Header.Panels[0].text := TrErreurCom;
      exit;
   end;
   VoieSerie.OutPut := 'XERR'+crCR;
   chaineLue := GetString;
   posOrphy := pos('ORPHY',chaineLue);
   OrphyPresent := posORPHY<>0;
   if OrphyPresent
      then setOrphyPresent
      else begin
       {$IFDEF DEBUG}
          VoieSerie.Tracing := tlDump;
          VoieSerie.Logging := tlDump;
      {$ENDIF}
         VoieSerie.Open := false;
      end;
end;

var i : integer;
begin { testOrphy }
   Header.Panels[0].text := trVerifGTS;
   testCom(NumCom);
   if not OrphyPresent then begin
      for i := 1 to MaxComHandles do begin
          if IsPortAvailable(i) and (i<>numCom) then testCom(i);
          if OrphyPresent then break;
      end;
   end;
   OrphyAbsent.visible := not OrphyPresent;
   if not OrphyPresent then begin
        Header.Panels[0].text := 'Orphy GTS non trouv sur COM'+
             intTostr(VoieSerie.ComNumber);
        OrphyAbsent.setFocus;
   end;
end; // testOrphy 

procedure TGTSmainForm.TimerTimer(Sender: TObject);

Procedure TimerPoint;
var distance : double;
    voie : indiceVoie;
begin with grapheGTS do begin
      LitPointAttente;
      if PointAutoCB.checked then if NbreAff=0
         then EnregistreBtnClick(sender)
         else begin
              distance := 0;
              for voie := voieA to voieMax do
              with voieOrphy[voie] do if active then
                   distance := distance+abs((valeurAff-vecteurAff[pred(NbreAff)])/(maxi-mini));
              if distance>0.01 then EnregistreBtnClick(sender);
         end;
end end;

Procedure TimerSA;
var etatSA : integer;
    termine : boolean;
begin with grapheGTS,sortieAnalogique do begin
     LitPointAttente;
     EnregistrePointCourant;
     if inverse
        then begin
           etatSA := finSortie-NbreAff;
           termine := etatSA<debutSortie
        end
        else begin
           etatSA := debutSortie+NbreAff;
           termine := etatSA>finSortie;
        end;
     if termine
         then begin
            etatAcq := eaTerminee;
            RegSaveBtn.enabled := NbreAff>=MinPointsFichier;
         end
         else begin
             ecritorphy('XSA '+intToStr(etatSA));
             valeurCourante := valeurReal(etatSA);
         end;
end end;

Procedure TimerMagnum;
var NbreCourant : integer;
begin with grapheGTS do begin
      nbreCourant := getWord('XUTIL4');
      if ((nbreCourant=nbreInter) and
          (NbreInter>0)) or
         (NbreInter>magnum.NbreMax) then StopMagnum;
      NbreInter := nbreCourant; 
end end;

begin with grapheGTS do begin
   case modeAcq of
       AcqTemps : case etatAcq of
           eaAttenteSynchro : case modeSynchro of
               s_clavier : LitPointAttente;
               s_seuil : ;
               s_bouge : ;
           end;
           eaAttenteResul : if relancerXresul then Xresul;
           eaTerminee : ;
       end;
       AcqClavier : LitPointAttente;
       AcqSortieAna : case etatAcq of
           eaAttenteSynchro : LitPointAttente;
           eaAttenteResul : TimerSA;
           eaTerminee : ;
       end;
       AcqPoint : TimerPoint;
       AcqMagnum :  case etatAcq of
           eaAttenteSynchro : ;
           eaAttenteResul : TimerMagnum;
           eaTerminee : ;
       end;
    end;
end end; // TimerTimer

procedure TGTSmainForm.EnregistreBtnClick(Sender: TObject);
begin
     case grapheGts.ModeAcq of
          AcqPoint : EnregistrePointCourant;
          AcqClavier : begin
                EnregistrePointCourant;
                ClavierEdit.setFocus;
          end;
          AcqTemps : LanceAcqTemps; { synchro clavier }
          AcqMagnum : LanceAcqMagnum; 
          AcqSortieAna : LanceAcqSA;
    end;
end;

procedure TGTSmainForm.FormKeypress(Sender: TObject;
  var Key: Char);
begin
     if EnregistreBtn.enabled and (key=' ') then begin
        case grapheGts.ModeAcq of
           AcqPoint,AcqSortieAna,AcqMagnum : enregistreBtnClick(sender);
           AcqTemps : if grapheGts.modeSynchro=s_clavier then
              enregistreBtnClick(sender);
           else exit;
        end;
        key := #0;
     end;
end;

Procedure TGTSmainForm.SetBoutons;
begin with grapheGTS do begin
     ResetBtn.enabled := NbreAff>0;
     EnregistreBtn.enabled := true;
     EnregistreBtn.hint := hAddPoint;
     StopBtn.enabled := etatAcq in [eaAttenteResul,eaAttenteSynchro];
     UndoBtn.enabled := (NbreAff>0) and (ModeAcq in [AcqPoint,AcqClavier]);
     case grapheGts.ModeAcq of
          AcqPoint : ;
          AcqSortieAna : ;
          AcqTemps : begin
                ResetBtn.enabled := Monocoup and (etatAcq=eaTerminee);
                EnregistreBtn.enabled := (modeSynchro=s_clavier) and
                                         (etatAcq=eaAttenteSynchro);
                Timer.enabled := true;
                EnregistreBtn.hint := hStart;
                case etatAcq of
                     eaAttenteSynchro : case modeSynchro of
                         s_clavier : Header.Panels[0].text := trWaitSynchro;
                         s_seuil : Header.Panels[0].text := trWaitSynchroSeuil;
                         s_bouge : Header.Panels[0].text := trWaitSynchroBouge;
                     end;    
                     eaTerminee : Header.Panels[0].text := trAcqFinie;
                     eaAttenteResul : if (modeSynchro=s_front) and
                                         (indexResul=0)
                       then Header.Panels[0].text := trWaitSynchroFront
                       else Header.Panels[0].text := trAttenteResul
                end;
          end;
          AcqMagnum : begin
               case etatAcq of
                     eaAttenteSynchro : Header.Panels[0].text := '';
                     eaTerminee : Header.Panels[0].text := trAcqFinie;
                     eaAttenteResul : Header.Panels[0].text := trAttenteResul;
               end;
          end;
          AcqClavier : EnregistreBtn.enabled := false;
     end;
     RegSaveBtn.enabled := NbreAff>=MinPointsFichier;
end end;

   Procedure TGTSmainForm.EnregistrePointCourant;
   var voie : indiceVoie;
   begin with grapheGts do begin
       for voie := voieSA to VoieMax do with voieOrphy[voie] do if active then
          if isnan(valeurCourante) then begin
             if not (voie in [voieClavier]) then
                LabelVoie.caption := erSansSignif;
             exit;
          end;
       effacePointCourant;
       with sortieAnalogique do valeurAff := ValeurCourante;
       for voie := voieClavier to VoieMax do
           with voieOrphy[voie] do if active then begin
              vecteurAff[nbreAff] := ValeurCourante;
              valeurAff := ValeurCourante;
              if voie<>voieAbscisse then traceUnPoint(voie);
       end;
       inc(NbreAff);
       marquePointCourant; 
       setBoutons;
   end end;{EnregistrePointCourant}

procedure TGTSmainForm.OscilloPaint(Sender: TObject);
var voie : indiceVoie;
begin with grapheGts do begin
     limiteFenetre := rect(0,0,oscillo.width,oscillo.height);
     oscillo.Canvas.brush.Color := clWindow;
     oscillo.Canvas.FillRect(limiteFenetre);
     draw;
     curseurSeuil := false;
     for voie := voieT to pred(VoieA) do
         with voieOrphy[voie] do
              valeurAff := mini;
     for voie := voieA to VoieMax do
         with voieOrphy[voie] do
              valeurAff := (mini+maxi)/2;
     if not(modeAcq in [AcqTemps,AcqMagnum]) and
        not(etatAcq in [eaAttenteResul])
            then marquePointCourant;
end end;

procedure TGTSmainForm.NombreDownClick(Sender: TObject);
begin
     GrapheGTS.NbreInter := grapheGTS.NbreInter div 2;
     SetNombre;
end;

procedure TGTSmainForm.NombreUpClick(Sender: TObject);
begin
     GrapheGTS.NbreInter := 2*GrapheGTS.NbreInter;
     SetNombre;
end;

function TGTSmainForm.duree125(duree : double) : double;
var coeff : double;
    exposant,mantisse : integer;
    negatif : boolean;
begin
     negatif := duree<0;
     duree := abs(duree);
     if duree<1e-6 then begin
        result := 0;
        exit;
     end;
     exposant := floor(log10(duree));
     coeff := power(10,exposant);
     mantisse := round(duree/coeff);
     if mantisse>2
        then if mantisse<6
             then mantisse := 5
             else mantisse := 10;
     coeff := mantisse*coeff;
     if negatif
        then result := -coeff
        else result := coeff
end;

procedure TGTSmainForm.DureeSpinUpClick(Sender: TObject);
begin
     SetLectureParametres;
     BaseDeTemps.maxi := duree125(2.15*BaseDeTemps.maxi);
     SetDuree;
end;

procedure TGTSmainForm.DureeSpinDownClick(Sender: TObject);
begin
     SetLectureParametres;
     BaseDeTemps.maxi := duree125(BaseDeTemps.maxi/2.15);
     SetDuree;
end;

Procedure TGTSmainForm.SetNombre;
begin
    SetLectureParametres;
    case grapheGTS.modeAcq of
       AcqTemps : begin
          BaseDeTemps.deltat := BaseDeTemps.maxi/GrapheGTS.NbreInter;
          AjusteDeltat;
       end;
    end;
    MajTemps;
end;

procedure TGTSmainForm.MajTemps;
var i : integer;
begin
    if grapheGTS.ModeAcq=AcqTemps then with BaseDeTemps do begin
       RegleTimer;
       deltatLabel.caption := 't='+chaineDuree(deltat);
       fechLabel.caption := 'Fech='+Frequence.formatUnite(1/deltat);
       minmax.visible := false;
           if BaseDeTemps.freqMin then begin
              minmax.visible := true;
              minmax.caption := 'Mini';
           end;
           if BaseDeTemps.freqMax then begin
              minmax.visible := true;
              minmax.caption := 'Maxi';
           end;
       NbreAffNul;
    end;
    NbreEdit.text := IntToStr(GrapheGTS.NbreInter);
    with BaseDeTemps do begin
       DureeEdit.text := chaineDuree(Maxi);
       for i := 0 to MaxVecteur do
           vecteurAff[i] := deltat*i;
    end;
    Gauge.position := 0;
    Gauge.Max := GrapheGTS.NbreInter;
    initAttente;
end;

Procedure TGTSmainForm.SetDuree;
var dureeMin : double;
begin
    if grapheGTS.ModeAcq<>AcqTemps then exit;
    if GrapheGTS.NbreVoie=1
           then dureeMin := 1e-4
           else dureeMin := minPointsTemps*GrapheGTS.NbreVoie*deltatOrphy;
    if BaseDeTemps.Maxi<dureeMin then
       BaseDeTemps.Maxi := dureeMin;
    if BaseDeTemps.Maxi>dureeMax then
       BaseDeTemps.Maxi := dureeMax;
    AjusteDeltat;
    GrapheGTS.NbreInter := round(BaseDeTemps.Maxi/BaseDeTemps.deltat);
    BaseDeTemps.Deltat := BaseDeTemps.Maxi/GrapheGTS.NbreInter;
    MajTemps;
end;

procedure TGTSmainForm.VoieAnaClick(Sender: TObject);
var v : indiceVoie;
begin
     SetLectureParametres;
     v := (sender as Tcomponent).tag;
     OrphyGtsDlg.voieCourante := grapheGTS.voieOrphy[v];
     OrphyGtsDlg.ShowModal;
     if OrphyGtsDlg.modif then begin
        NbreAffNul;
        for v := voieA to voieAnaMax do
            grapheGTS.voieOrphy[v].NumOrphy := grapheGTS.voieOrphy[v].NumOrphy;
     end;
     afficheReglage;
end;

procedure TGTSmainForm.ClavierGBClick(Sender: TObject);
begin
    SetLectureParametres;
    ClavierDlg := TClavierDlg.create(self);
    ClavierDlg.showModal;
    ClavierDlg.free;
    afficheReglage;
end;

procedure TGTSmainForm.FormClose(Sender: TObject;
  var Action: TCloseAction);

procedure sauveExtension;
var regist : Tregistry;
begin
  Regist := TRegistry.create;
  Regist.RootKey := HKey_Classes_Root;
  if Regist.OpenKey('\.gts',true) then begin
     Regist.WriteString('','GTSFile');
     Regist.WriteString('Content Type','application\gts');
  end;
  if Regist.OpenKey('\GTSFile',true) then begin
     Regist.WriteString('','Fichier config. GTS');
     Regist.WriteString('IsShortcut','');
     if Regist.OpenKey('\GTSFile\shell',true) then
        Regist.WriteString('','open');
     if Regist.OpenKey('\GTSFile\shell\open\command',true) then
        Regist.WriteString('','"'+application.exename+'" "%1"');
     if Regist.OpenKey('\GTSFile\shell\open\ddeExec',true) then
        Regist.WriteString('','FILE|LOAD(%1)');
     if Regist.OpenKey('\GTSFile\shell\open\ddeExec\topic',true) then
        Regist.WriteString('','ServeurDDE');
     if Regist.OpenKey('\GTSFile\shell\open\ddeExec\application',true) then
        Regist.WriteString('','GTS');
  end;
  regist.free;
end;
               
var FichierIni : TRegIniFile;
begin
     Timer.enabled := false;
     if StopBtn.enabled then StopBtnClick(nil);
     case grapheGTS.modeAcq of
          AcqTemps : ecritOrphy('XPEA0 0,1');
          AcqMagnum : ecritOrphy('XRESET');
     end;
     StopAttenteSeuil;
   {$IFDEF DEBUG}
     VoieSerie.Tracing := tlDump;
     VoieSerie.Logging := tlDump;
   {$Endif}
     try
     FichierIni := TRegIniFile.create(RegistreGTS);
     FichierIni.writeInteger('COM','Num',numCom);
     FichierIni.writeString('Config','Path',CfgGTSPath);
     FichierIni.writeBool('Config','Trace',avecTrace);
     FichierIni.WriteInteger('Window','State',ord(WindowState));
     FichierIni.free;
     SauveExtension;
     except
     end;
     EcritConfig(MesDocsDir+'GTS');
end; // FormClose

procedure TGTSmainForm.WMFileLoad(var Msg : TMessage);
var nomFichier : String;
begin
      NomFichier := ClipBoard.asText;
      if pos('\',NomFichier)=0 then
         NomFichier := MesDocsDir+NomFichier;
      LitConfig(nomFichier);
end;

procedure TGTSmainForm.RegSaveBtnClick(Sender: TObject);
var sauveTimer : boolean;
begin
   SauveTimer := Timer.enabled;
   SetLectureParametres;
   if ConstanteDlg.showModal=mrOk
      then begin
         FormDDE.EnvoieDonnees(true);
         ReactiverGTS := true;
      end
      else Timer.enabled := SauveTimer
end;

procedure TGTSmainForm.UndoBtnClick(Sender: TObject);
begin // Supprimer dernier point 
     if grapheGts.NbreAff>0 then begin
        dec(grapheGts.NbreAff);
        oscillo.refresh;
        setBoutons;
     end;
end;

procedure TGTSmainForm.TriggerAvail(CP: TObject; Count: Word);
var carac : ansichar;
    i : integer;
begin
     try
     for i := 1 to count do begin
         if voieSerie.charReady then begin
         carac := voieSerie.getChar;
         if carac in [',',crcR]
            then begin
                 if chaineRecue<>'' then begin
                    try
                    tableauOrphy[indexResul] := strToInt(chaineRecue);
                    chaineRecue := '';
                    inc(indexResul);
                    except
                    end;
                 end;
           end
           else if (carac>='0') and
                   (carac<='9') then chaineRecue := chaineRecue+carac;
           if carac=crCR then if indexResul>0
              then litCanVecteur
              else RelancerXresul := true;
         end;
     end; // for i
     except
     end;
end;

procedure TGTSmainForm.SortieAnaGBClick(Sender: TObject);
begin
    SetLectureParametres;
    SortieAnaDlg := TSortieAnaDlg.create(self);
    SortieAnaDlg.showModal;
    SortieAnaDlg.free;
    afficheReglage;
end;

procedure TGTSmainForm.StopBtnClick(Sender: TObject);
begin with GrapheGts do begin
   case modeAcq of
        AcqTemps : begin
           if sender<>nil then begin
              MonocoupCB.checked := true;
              Monocoup := true;
           end;
           if (baseDeTemps.maxi>0.1) or
              (modeSynchro<>s_clavier) or
               not premiereAcquisition then begin
                   ecritOrphy('XPEA0 0,1');
                   setLectureParametres;
                   etatAcq := eaTerminee;
            end;
            relancerXresul := false;
        end;
        AcqMagnum : stopMagnum;
        else begin
            setLectureParametres;
            etatAcq := eaTerminee;
        end;
   end;
   SetBoutons;
   ResetBtn.enabled := true;
   ArretSeuil := true;
end end;

procedure TGTSmainForm.ResetBtnClick(Sender: TObject);
begin
     if (grapheGts.modeAcq=AcqTemps) or (sender=nil) or
        OKreg(trDelAcq) then begin
          if sender<>nil then NbreAffNul;
          oscillo.refresh;
          initAttente;
     end;
end;

procedure TGTSmainForm.HelpBtnClick(Sender: TObject);
begin
   Application.HelpShowTableOfCONTENTS
end;

procedure TGTSmainForm.ClavierEditKeyPress(Sender: TObject; var Key: Char);
begin
     if key=crCR then with entreeClavier do begin
        valeurCourante := StrToFloatWin(ClavierEdit.text);
        if (valeurCourante>maxi) or
           (valeurCourante<mini) or
           isnan(valeurCourante) then begin
           AfficheErreurStr(FormatGts(mini)+'< '+nom+' <'+FormatGts(maxi));
           ClavierEdit.setFocus;
           exit;
        end;
        effacePointCourant;
        valeurAff := valeurCourante;
        marquePointCourant;
        EnregistreBtnClick(nil);
        ClavierEdit.text := '';
        key := #0;
     end;
end;

procedure TGTSmainForm.CapteursItemClick(Sender: TObject);
var sauveTimer : boolean;
begin
   SauveTimer := Timer.enabled;
   SetLectureParametres;
   ChoixCapteursDlg := TChoixCapteursDlg.create(self);
   ChoixCapteursDlg.showModal;
   ChoixCapteursDlg.free;
   Timer.enabled := SauveTimer;
end;

procedure TGTSmainForm.ComBtnClick(Sender: TObject);
begin
     screen.cursor := crHourGlass;
     testOrphy;
     screen.cursor := crDefault;
end;

procedure TGTSmainForm.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin
     with Msg.MinMaxInfo^ do begin
          ptMinTrackSize := point(550,380);
          ptMaxTrackSize := point(screen.width,screen.height);
     end;
end;

procedure TGTSmainForm.PointAutoCBClick(Sender: TObject);
begin
     if PointAutoCB.checked
          then Header.Panels[0].text := hPointAuto
          else Header.Panels[0].text := hPoint
end;

procedure TGTSmainForm.EscapeBtnClick(Sender: TObject);
begin
     Application.Terminate
end;

procedure TGTSmainForm.WMSetFocus(var Msg: Tmessage);
begin
      if ReactiverGTS then with grapheGts do begin
         ReactiverGTS := false;
         if modeAcq<>AcqTemps then begin
            Timer.enabled := orphyPresent;
            exit;
         end;
         Timer.enabled := false;
         EnregistreBtn.enabled := true;
         voieOrphy[voieT].valeurCourante := 0;
         initAttente;
         Msg.result := 0;
      end;
end;

procedure TGTSmainForm.DureeEditKeyPress(Sender: TObject; var Key: Char);
begin
     case key of
        crCR : begin
           try
           BaseDeTemps.Maxi := dateTimeToFloat(dureeEdit.text);
           setDuree;
           except
              DureeEdit.text := chaineDuree(BaseDeTemps.Maxi);
           end;
        end;
        '.',',' : key := decimalSeparator;
        '0'..'9','m','','s',' ','i','n' : ;
        crDroite,crGauche,crSuppr,crSupprArr : ;
        else key := #0
     end;
end;

procedure TGTSmainForm.NbreEditKeyPress(Sender: TObject; var Key: Char);
begin
     case key of
        crCR : begin
           try
           GrapheGTS.NbreInter := StrToInt(NbreEdit.text);
           setNombre;
           except
           NbreEdit.text := intToStr(GrapheGTS.NbreInter);
           end;
        end;
        '0'..'9' : ;
        crDroite,crGauche,crSuppr,crSupprArr : ;
        else key := #0;
     end;
end;

procedure TGTSmainForm.DureeEditExit(Sender: TObject);
var newmaxi : double;
begin
     try
     NewMaxi := dateTimeToFloat(dureeEdit.text);
     if newMaxi<>BaseDeTemps.Maxi then begin
         BaseDeTemps.Maxi := newmaxi;
         setDuree;
     end;
     except
          DureeEdit.text := chaineDuree(BaseDeTemps.Maxi);
     end;
end;

procedure TGTSmainForm.NbreEditExit(Sender: TObject);
var newnbre : integer;
begin
    try
    newNbre := StrToInt(NbreEdit.text);
    if newNbre<>GrapheGTS.NbreInter then begin
       GrapheGTS.NbreInter := newNbre;
       setNombre;
    end;
    except
       NbreEdit.text := intToStr(GrapheGTS.NbreInter);
    end;
end;

procedure TGTSmainForm.FormResize(Sender: TObject);
begin
     if PleinEcranItem.checked then begin
         PanelCourbe.Width := ClientWidth;
         PanelCourbe.Height := ClientHeight-Header.height-ToolBar1.height;
     end;
     Header.Panels[0].Width := ClientWidth div 2;
     SetSizeVoie;
end;

Procedure TGTSmainForm.SetSizeVoie;

Procedure GrandeTaille;
var voie : indiceVoie;
    Hauteur,NbreVoieAna : integer;
    HauteurFonteGB,HauteurFonteLabel : integer;
    Largeur,largeurBis : integer;
begin with grapheGTS do begin
   NbreVoieAna := 0;
   for voie:=voieA to VoieAnaMax do
       if voieOrphy[voie].active then inc(NbreVoieAna);
   if (NbreVoieAna=0) and (modeAcq<>AcqMagnum) then begin
      voieOrphy[voieA].active := true;
      inc(NbreVoieAna);
   end;
   for voie := voieA to VoieMax do with voieOrphy[voie] do
      if not active then begin
            GBvoie.color := clBtnFace;
            GBvoie.height := 28;
            GBvoie.font.size := 8;  { points soit 11 en hauteur }
      end;
   Hauteur := PanelVoies.height div NbreVoieAna;
   for voie := voieA to voieMax do with voieOrphy[voie] do
       if active then begin
                       GBvoie.color := clWhite;
                       LabelVoie.font.color := couleur;
                       GBvoie.font.color := couleur;
             Largeur := length(GBvoie.caption);
             if Largeur=0 then largeur := 12;
             Largeur := (2*PanelVoies.width) div largeur;
             LargeurBis := PanelVoies.width div 4;
             if LargeurBis<Largeur then Largeur := LargeurBis;
             if largeur<13 then largeur := 13; { 13 = 10 points }
             if Largeur*3<Hauteur then Hauteur := Largeur*3;
       end;
   HauteurFonteGB := 2*(hauteur div 12);
   if hauteurFonteGB<15 then HauteurFonteGB := 15;
   HauteurFonteLabel := Hauteur - 3*HauteurFonteGB;
   LargeurBis := PanelVoies.width div 4;
        { 6 caractres hauteur = 2/3 largeur }
   if LargeurBis<HauteurFonteLabel then HauteurFonteLabel := LargeurBis;
   HauteurFonteLabel := 2*(hauteurFonteLabel div 2);
   if hauteurFonteLabel<15 then HauteurFonteLabel := 15;
   hauteur := HauteurFonteGB+HauteurFonteLabel;
   for voie := voieEB to voieMax do with voieOrphy[voie] do
       if active then begin
             GBvoie.color := couleur;
             GBvoie.height := hauteur;
             Gbvoie.font.name := 'Calibri';
             if hauteurFonteGB=15
                then Gbvoie.font.size := 12
                else GBvoie.font.height := HauteurFonteGB;
             if hauteurFonteLabel=15
               then begin
                  LabelVoie.font.size := 12;
                  LabelVoie.font.name := 'Courier';
               end
               else begin
                  LabelVoie.font.name := 'Courier New';
                  LabelVoie.font.height := HauteurFonteLabel;
               end;
             LabelVoie.top := HauteurFonteGB;
     end;
end end;

Procedure petiteTaille;
var voie : indiceVoie;
    Fsize : integer;
begin
if height>600
   then Fsize := 14
   else if height>480
        then Fsize := 12
        else Fsize := 10;
with grapheGTS do
    for voie := voieEB to voieMax do with voieOrphy[voie] do
       if active then begin
                     GBvoie.color := clWhite;
                     LabelVoie.font.color := couleur;
                     GBvoie.font.color := couleur;
             GBvoie.height := 4*Fsize;
             Gbvoie.font.size := Fsize;
             Gbvoie.font.name := 'Calibri';
             LabelVoie.font.name := 'Courier';
             LabelVoie.font.size := Fsize+2;
             LabelVoie.top := 3*Fsize div 2;
       end
       else begin
             GBvoie.color := clBtnFace;
             GBvoie.height := 2*Fsize;
             GBvoie.font.size := Fsize-2;
       end;
end;

begin
    if VoltMetreItem.checked
       then grandeTaille
       else petiteTaille;
end;

procedure TGTSmainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=vk_F5 then if PleinEcranItem.checked
          then GrapheVolt.Checked := true
          else PleinEcranItem.Checked := true;
     if key=vk_F6 then if VoltmetreItem.checked
          then GrapheVolt.Checked := true
          else VoltmetreItem.Checked := true;
     if (key=vk_F5) or (key=vk_F6) then
          PleinEcranClick(Sender);
end;

function WordPosition(const N: Integer; const S: string;
  const WordDelims: TsysCharSet): Integer;
var
  Count, I: Integer;
begin
  Count := 0;
  I := 1;
  Result := 0;
  while (I <= Length(S)) and (Count <> N) do begin
    { skip over delimiters }
    while (I <= Length(S)) and charinset(S[I],WordDelims) do Inc(I);
    { if we're not beyond end of S, we're at the start of a word }
    if I <= Length(S) then Inc(Count);
    { if not finished, find the end of the current word }
    if Count <> N then
      while (I <= Length(S)) and not charinset(S[I],WordDelims) do Inc(I)
    else Result := I;
  end;
end;

procedure TGTSmainForm.EntreeBinGBClick(Sender: TObject);
begin
    SetLectureParametres;
    EntreeBinDlg := TEntreeBinDlg.create(self);
    EntreeBinDlg.showModal;
    EntreeBinDlg.free;
    afficheReglage;
end;

procedure TGTSmainForm.MonocoupCBClick(Sender: TObject);
begin
     Monocoup := MonocoupCB.checked;
     if not monocoup then initAttente;
end;

procedure TGTSmainForm.WMFClick(Sender: TObject);
var ametafileCanvas : TmetafileCanvas;
    ametafile : Tmetafile;
begin
    Ametafile := Tmetafile.Create;
    ametafile.Width := Width;
    ametafile.Height := Height;
    AmetafileCanvas := TmetaFileCanvas.create(AMetafile,0);
    PaintTo(ametafileCanvas.Handle, 0, 0);
    AmetafileCanvas.free;
    AmetaFile.saveToFile(MesDocsDir+'GTS.WMF');
    AmetaFile.free;
end;

Procedure TGTSmainForm.NbreAffNul;
begin
     grapheGts.NbreAff := 0;
     RegSaveBtn.enabled := false;
end;

procedure TgtsMainForm.Xresul;

procedure litOrphyTableau(idebut : integer;pas : byte);
var demande : ansiString;
    NbreResulMax,indexResulMax : integer;
begin
   indexResulMax := grapheGTS.NbreInter*pas-iDebut;
   nbreResulMax := round(1/BaseDeTemps.deltat);
   if NbreResulMax<2*pas then NbreResulMax := 2*pas;
   NbreResulMax := NbreResulMax*pas;
   if NbreResulMax>255 then NbreResulMax := pas*(255 div pas);
   if indexResulMax>NbreResulMax then indexResulMax := NbreResulMax;
   demande := 'XRESUL '+
      intToStr(idebut div longueurBloc)+','+
      intToStr(idebut mod longueurBloc)+','+
      intToStr(indexResulMax);
   VoieSerie.onTriggerAvail := TriggerAvail;
   indexResul := 0;
   chaineRecue := '';
   etatAcq := eaAttenteResul;
   ecritOrphy(demande);
end;

begin
   RelancerXresul := false;
   case baseDeTemps.Pea of
      Pea0 : LitOrphyTableau(Npea0*debutLecture,Npea0);
      Pea1 : LitOrphyTableau(debutLecture,1);
      Pea2 : begin
          if debutLecture>0 then dec(debutLecture); { pour interpolation }
          LitOrphyTableau(2*debutLecture,2);
      end;
      Pea40,pea41 : LitOrphyTableau(4*debutLecture,4);
      Pea8 : begin
        if debutLecture>0 then dec(debutLecture); { pour interpolation }
        LitOrphyTableau(8*debutlecture,8);
      end;
   end;
end; { Xresul }

procedure TGTSmainForm.PlusBtnClick(Sender: TObject);
begin
   (sender as TtoolButton).CheckMenuDropdown
end;

procedure TGTSmainForm.EFRGClick(Sender: TObject);
begin
     ordreLance := 'XSEAP '+ansichar(grapheGts.frontSynchro+ord('0'));
end;

procedure TGTSmainForm.SynchroGBClick(Sender: TObject);
begin
    SetLectureParametres;
    if synchroDlg.showModal=mrOK then ;
    afficheReglage;
end;

procedure TGTSmainForm.LanceAttenteSeuil;
var id,code : cardinal;
begin
      if FThreadSeuil<>0 then begin
         if getExitCodeThread(FThreadSeuil,code) and
            (code=Still_active) then exit;
          closeHandle(FThreadSeuil);
          FThreadSeuil := 0;
      end;
      voieSerieSeuil := voieSerie;
      ArretSeuil := false;
      Timer.enabled := false;
      etatAcq := eaAttenteSynchro;
      StopBtn.Enabled := true;
      voieSerie.OnTriggerAvail := nil;
      Header.Panels[0].text := trWaitSynchroSeuil;
      charSynchro := ansichar(64+grapheGTS.voieOrphy[grapheGTS.voieSynchro].NumOrphy);
      FThreadSeuil := CreateThread(nil,0,@AttenteSeuil,nil,0,id);
end;

procedure TGTSmainForm.LanceAttenteBouge;
var id,code : cardinal;
begin
      if FThreadSeuil<>0 then begin
         if getExitCodeThread(FThreadSeuil,code) and
            (code=Still_active) then exit;
          closeHandle(FThreadSeuil);
          FThreadSeuil := 0;
      end;
      voieSerieSeuil := voieSerie;
      ArretSeuil := false;
      Timer.enabled := false;
      etatAcq := eaAttenteSynchro;
      StopBtn.Enabled := true;
      voieSerie.OnTriggerAvail := nil;
      Header.Panels[0].text := trWaitSynchroBouge;
      charSynchro := ansichar(64+grapheGTS.voieOrphy[grapheGTS.voieSynchro].NumOrphy);
      FThreadSeuil := CreateThread(nil,0,@AttenteBouge,nil,0,id);
end;

procedure TGTSMainForm.StopAttenteSeuil;
var code : cardinal;
    acqEnCours : boolean;
begin
      if FThreadSeuil<>0 then begin
         ArretSeuil := true;
         repeat
             AcqEnCours := getExitCodeThread(FThreadSeuil,code) and
                           (code=Still_active);
         until not AcqEnCours;
         closeHandle(FThreadSeuil);
         FThreadSeuil := 0;
     end;
end;

procedure TGTSmainForm.OscilloMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
const minSynchro = 8;  
begin with grapheGTS do begin
   Oscillo.hint := '';
   Oscillo.cursor := crDefault;
   if curseurSeuil and (ssLeft in Shift)
      then affecteSeuil(y)
      else if modeSynchro=s_seuil then begin
            if (abs(y-yseuil)<4) then begin
               Oscillo.hint := '|Seuil de dclenchement';
               Oscillo.cursor := crVsplit;
            end;
        end;
end end;

procedure TGTSmainForm.OscilloMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  with grapheGTS do
       curseurSeuil := (modeSynchro=s_seuil) and (abs(y-yseuil)<4);
end;

procedure TGTSmainForm.OscilloMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if curseurSeuil then begin
      affecteSeuil(y);
      curseurSeuil := false;
      afficheReglage;
  end;
end;

procedure TGTSmainForm.PleinEcranClick(Sender: TObject);
begin
     if PleinEcranItem.checked
        then begin
             PanelCourbe.Align := alNone;
             PanelCourbe.Width := ClientWidth;
             PanelCommande.width := 256;
        end
        else if VoltMetreItem.checked
        then begin
             PanelCourbe.Align := alClient;
             PanelCommande.width := ClientWidth-6;
             PanelMode.width := 2;
        end
        else begin
             PanelCourbe.Align := alClient;
             PanelCommande.width := 256;
             PanelMode.width := 128;
        end;
     setSizeVoie;
end;

procedure TGTSmainForm.Splitter1Moved(Sender: TObject);
begin
  setSizeVoie
end;

procedure TGTSmainForm.affecteSeuil(y : integer);
const minSynchro = 8;
var seuil : integer;
begin with grapheGTS do begin
     with voieOrphy[voieSynchro] do
          seuil := round(255*(y-CourbeBottom)/(CourbeTop-CourbeBottom));
     if (seuil>minSynchro) and
        (seuil<(255-minSynchro)) then begin
            TraceLigneSynchro;
            seuilSynchro := seuil;
            TraceLigneSynchro;
     end;
end end;

procedure TGTSmainForm.CopyDataClick(Sender: TObject);
var sauveTimer : boolean;
begin
   SauveTimer := Timer.enabled;
   FormDDE.EnvoieDonnees(true);
   ReactiverGTS := true;
   Timer.enabled := SauveTimer
end;

procedure TGTSmainForm.SaveDataClick(Sender: TObject);
begin
   SaveDialog.filter := 'Fichier ASCII|*.Txt';
   if SaveDialog.Execute then
       FormDDE.sauveDonnees(SaveDialog.FileName);
end;

Procedure TGTSmainForm.ChargeMagnum;
const
nbre = 24;
UtilMagnum : array[1..Nbre] of String[64] =
(':083E3B0006204420EA20422188',
 ':10200000000000000000BA14D320701E063E4843B2',
 ':1020100000143075701E0220145A21701E5C3E7030',
 ':102020001E603E14003E701E5E3E140000701E04D2',
 ':102030002014B020701E083E69044DCC484700644F',
 ':102040000F77AAB8BA140000701E002044000048A0',
 ':10205000D214C720701E043E484500146E20701E26',
 ':10206000083E69044DCC484700640FDFAAB8111040',
 ':10207000701F042012701E0420702F603E701F021B',
 ':1020800020134CC54780C21212701E0220A5489230',
 ':102090002222701F0020A54892222248C148922285',
 ':1020A00022702E603E743C3D641FA81110A1AA62EC',
 ':1020B0001110701F0220134CC54780C21212701EEF',
 ':1020C00002201110A1AA62701F002012701E0020B1',
 ':1020D000A1AA621011701F0220134CC55780C212B2',
 ':1020E00012701E02201011A1AA62B270691C3E7704',
 ':0F20F00001641F88690170796F3E702F5C3E702C',
 ':1020FF001F603EA574AE4E33488240121F40061F2C',
 ':10210F0022227069163E40AA0C488240121F4006D8',
 ':10211F001F22227069163E40AA0C488240121F40AF',
 ':10212F00061F2222690D40AA0C4FC4A269007079C4',
 ':10213F006F3EB87069163E6700C5701F0220C470ED',
 ':0D214F001F0420A540121F40061FB800000D',
 ':00000001FF');

var i : integer;
    messageOrphy : ansiString;
begin
      if UtilMagnumCharge then exit;
      screen.Cursor := crHourGlass;
      label8.Visible := true;
      for i := 1 to Nbre do ecritOrphy(UtilMagnum[i]);
      DelayS(0.3);
      messageOrphy := GetString;
      UtilMagnumCharge := pos('UTIL',messageOrphy)>0;
      if not UtilMagnumCharge then begin
         showMessage('Impossible d''utiliser Magnum');
         grapheGTS.modeAcq := AcqPoint;
      end;
      screen.Cursor := crDefault;
      label8.Visible := false;
end;

procedure TGTSmainForm.GroupBox3Click(Sender: TObject);
begin
     MagnumCfg := TMagnumCfg.create(self);
     MagnumCfg.showModal;
     MagnumCfg.free;
     afficheReglage;
end;

procedure TGTSmainForm.StopMagnum;
begin with grapheGTS do begin
       EcritOrphy('XUTIL3 32');
       screen.Cursor := crHourGlass;
       voieSerie.onTriggerAvail := triggerAvailMagnum;
       magnum.NbreMagnum := 0;
       Gauge.max := NbreInter;
       Gauge.position := 0;
       etatAcq := eaAttenteResul;
       if (MagnumStopDlg<>nil) and
           MagnumStopDlg.visible then MagnumStopDlg.close;
       stopBtn.enabled := false;
       Timer.Enabled := false;
end end; // stopMagnum

procedure TGTSmainForm.MagnumAutoCBClick(Sender: TObject);
begin
//    if EnregistreBtn.enabled then EnregistreBtn.setFocus
     { pour que la CB ne garde pas le focus }
end;

procedure TGTSmainForm.TriggerAvailMagnum(CP: TObject; Count: Word);

Procedure MajResulMagnum;
begin with grapheGTS,magnum do begin
          TestChute;
          timer.enabled := false;
          EtatAcq := eaTerminee;
          RecopieMagnum;
          if NbreMagnum>2
              then BaseDeTemps.Maxi := VoieOrphy[voieT].vecteurAff[pred(NbreMagnum)]
              else BaseDeTemps.Maxi := 0.25;
          NbreAff := NbreInter;    
          Oscillo.refresh;
          setBoutons;
end end;

procedure TriggerMagnum;
var carac : ansichar;
begin
   carac := voieSerie.getChar;
   if carac>=' ' then magnum.reponse := magnum.reponse+carac;
   if carac=crCR then with grapheGTS do begin
         VoieOrphy[voieT].vecteurAff[magnum.NbreMagnum] := Magnum.date;
         magnum.reponse := '';
         inc(magnum.NbreMagnum);
         Gauge.position := magnum.NbreMagnum;
         if magnum.NbreMagnum=NbreInter then begin
               MajResulMagnum;
               VoieSerie.onTriggerAvail := nil;
               screen.Cursor := crDefault;
          end;
      end;
end;

var i : integer;
begin
     for i := 1 to count do begin
        if VoieSerie.CharReady { test non utile et prjudiciable ? }
           then triggerMagnum
           else exit;{ ne devrait pas arriver mais arrive ? }
     end;{ i }
end; // TriggerAvailMagnum

end.

