unit Modedlg;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Spin, ExtCtrls, sysutils,
  gtsdef, graphe, gtsmain, constgts, aidekey;

type
  TmodeAcqDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Panel1: TPanel;
    ModeRG: TRadioGroup;
    AbscisseRG: TRadioGroup;
    TraceGB: TGroupBox;
    TraceLigneCB: TCheckBox;
    TracePointsCB: TCheckBox;
    Label3: TLabel;
    DimPointSE: TSpinEdit;
    HelpBtn: TBitBtn;
    GroupBox1: TGroupBox;
    AnalyseurLogiqueCB: TCheckBox;
    AxeCB: TCheckBox;
    GrilleCB: TCheckBox;
    MasseRG: TRadioGroup;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ModeRGClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure AnalyseurLogiqueCBClick(Sender: TObject);
  private
    NumVoieAbs : array[0..voieMax] of indiceVoie;
    oldModeAcq : TmodeAcq;
    Procedure setAbscisseRG;
  public
    modif : boolean;
  end;

var
  modeAcqDlg: TmodeAcqDlg;

implementation

uses clavier, sadlg;

{$R *.DFM}

procedure TmodeAcqDlg.OKBtnClick(Sender: TObject);
begin with grapheGts do begin
     MasseFlottante := masseRG.ItemIndex>0;
     Modif := modeAcq<>TmodeAcq(modeRG.itemIndex);
     ModeAcq := TmodeAcq(modeRG.itemIndex);
     case modeAcq of
         AcqClavier : VoieAbscisse := VoieClavier;
         AcqMagnum : VoieAbscisse := voieT;         
         AcqSortieAna : VoieAbscisse := VoieSA;
         else VoieAbscisse := NumVoieAbs[AbscisseRG.itemIndex];
     end;
     oTraceLigne := TraceLigneCB.checked;
     oTracePoints := TracePointsCB.checked;
     Quadrillage := GrilleCB.checked;
     avecUnAxe := AxeCB.checked;
     analyseurLogique := AnalyseurLogiqueCB.checked;
     dimPoint := dimPointSE.value;
     if modif and (modeAcq=AcqClavier) then begin
         ClavierDlg := TClavierDlg.create(self);
         ClavierDlg.showModal;
         ClavierDlg.free;
     end;
end end;

procedure TmodeAcqDlg.FormActivate(Sender: TObject);
begin with grapheGts do begin
     masseRG.ItemIndex := ord(MasseFlottante);
     modeRG.itemIndex := ord(modeAcq);
     TraceLigneCB.checked := oTraceLigne;
     TracePointsCB.checked := oTracePoints;
     GrilleCB.checked := Quadrillage;
     AnalyseurLogiqueCB.checked := analyseurLogique;
     Modif := false;
     oldModeAcq := modeAcq;
     SetAbscisseRG;
     AxeCB.checked := avecUnAxe;
     DimPointSE.value := dimPoint;
end end;

Procedure TmodeAcqDlg.setAbscisseRG;
var voie : indiceVoie;

Procedure setNum;
begin
     numVoieAbs[pred(abscisseRG.items.count)] := voie;
     if (modeRG.itemIndex=ord(grapheGts.modeAcq)) and
        (voie=grapheGTS.voieAbscisse) then
        AbscisseRG.itemIndex := pred(abscisseRG.items.count);
end;

var texte : string;
    AcqCourant : TmodeAcq;
begin
     AbscisseRG.items.clear;
     AcqCourant := TModeAcq(ModeRG.itemIndex);
     AbscisseRG.enabled :=
          not (AcqCourant in [acqClavier,acqSortieAna,acqMagnum]);
     for voie := voieT to voieMax do case voie of
         voieClavier : if (AcqCourant=AcqClavier) then begin
              AbscisseRG.items.Add('Clavier');
              AbscisseRG.itemIndex := pred(abscisseRG.items.count);
              setNum
         end;
         voieT : if (AcqCourant=AcqTemps) then begin
              AbscisseRG.items.Add(trTemps);
              if acqTemps<>grapheGts.modeAcq then
                 AbscisseRG.itemIndex := pred(abscisseRG.items.count);
              setNum
         end;
         voieSA : if (AcqCourant=AcqSortieAna) then begin
              AbscisseRG.items.Add('sortie ana.');
              AbscisseRG.itemIndex := pred(abscisseRG.items.count);
              setNum
         end;
         else with grapheGTS.voieOrphy[voie] do if active then begin
            if length(signif)<length(nom)
               then texte := nom
               else if (length(nom)+length(signif))<16
                   then texte := nom+'/'+signif
                   else texte := signif;
            AbscisseRG.items.Add(texte);
            if (modeRG.itemIndex<>ord(grapheGts.modeAcq)) and
               (ModeRG.itemIndex=ord(AcqPoint)) and
               (AbscisseRG.itemIndex=-1) then
                  AbscisseRG.itemIndex := pred(abscisseRG.items.count);
            setNum;
         end;
      end;
end;

procedure TmodeAcqDlg.ModeRGClick(Sender: TObject);
begin
      setAbscisseRG
end;

procedure TmodeAcqDlg.HelpBtnClick(Sender: TObject);
begin
    Application.HelpContext(HELP_ModeAcquisition)
end;

procedure TmodeAcqDlg.AnalyseurLogiqueCBClick(Sender: TObject);
begin
      AxeCB.Visible := not AnalyseurLogiqueCB.checked
end;

end.



