unit MagnumDlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, gtsUtil, Spin, ooMisc;

type
  TMagnumCfg = class(TForm)
    LabelTaille: TLabel;
    TailleTraitEdit: TEdit;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Label1: TLabel;
    NomMagnumEdit: TEdit;
    ModeRG: TRadioGroup;
    UniteRG: TRadioGroup;
    HelpBtn: TBitBtn;
    NegatifCB: TCheckBox;
    NbreMaxSE: TSpinEdit;
    Label2: TLabel;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ModeRGClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure NomMagnumEditChange(Sender: TObject);
  private
  public
  end;

var
  MagnumCfg: TMagnumCfg;

implementation

uses graphe, GTSdef, GTSMAIN;

{$R *.DFM}

procedure TMagnumCfg.OKBtnClick(Sender: TObject);
begin with magnum do begin
    traitMagnumE := GetFloat(TailleTraitEdit.text);
    modeAngulaire := boolean(ModeRG.itemIndex);
    modeRadian := boolean(UniteRG.itemIndex);
    nom := NomMagnumEdit.text;
    NbreMax := NbreMaxSE.Value;
    negatif := negatifCB.checked;
end end;

procedure TMagnumCfg.FormActivate(Sender: TObject);
begin with magnum do begin
    TailleTraitEdit.text := formatGts(traitMagnumE);
    ModeRG.itemIndex := ord(modeAngulaire);
    NbreMaxSE.Value := NbreMax;
    UniteRG.itemIndex := ord(modeRadian);
    NomMagnumEdit.text := Nom;
    negatifCB.checked := negatif;
end end;

procedure TMagnumCfg.ModeRGClick(Sender: TObject);
begin
     UniteRG.visible := ModeRG.itemIndex = 1;
     TailleTraitEdit.visible := LabelTaille.visible;
     NegatifCB.caption := NomMagnumEdit.text+' ngatif en cas de chute';
end;

procedure TMagnumCfg.HelpBtnClick(Sender: TObject);
begin
    Application.HelpContext(Help_index)
end;

procedure TMagnumCfg.NomMagnumEditChange(Sender: TObject);
begin
     NegatifCB.caption := NomMagnumEdit.text+' ngatif';
end;

end.

