unit Sadlg;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, spin, ExtCtrls, sysutils, Grids, Dialogs, TabNotBk,
  maths, gtsutil, uniteker, gtsdef, graphe, gtsmain, constgts, aidekey;

type
  TSortieAnaDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Panel1: TPanel;
    DebutGB: TGroupBox;
    DebutSAScroll: TScrollBar;
    EditDebutSA: TEdit;
    FinGB: TGroupBox;
    FinSAScroll: TScrollBar;
    EditFinSA: TEdit;
    GroupBox1: TGroupBox;
    EditNomSA: TEdit;
    HelpBtn: TBitBtn;
    GroupBox2: TGroupBox;
    DeltatEdit: TEdit;
    DeltatSBtn: TSpinButton;
    InverseCB: TCheckBox;
    EtalonCB: TCheckBox;
    procedure DebutSAScrollChange(Sender: TObject);
    procedure FinSAScrollChange(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SortieRGClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure DeltatSBtnDownClick(Sender: TObject);
    procedure DeltatSBtnUpClick(Sender: TObject);
  private
    activation : boolean;
    procedure MajDeltat;
  public
  end;

var
  SortieAnaDlg: TSortieAnaDlg;

implementation

{$R *.DFM}

procedure TSortieAnaDlg.DebutSAScrollChange(Sender: TObject);
begin with sortieAnalogique do begin
     if DebutSAScroll.position>FinSAScroll.position-8 then
        DebutSAScroll.position := FinSAScroll.position-8;
     EditDebutSA.text := FormatUnite(ValeurReal(DebutSAScroll.position));
     GtsMainForm.EcritOrphy('XSA '+IntToStr(DebutSAScroll.position));
end end;

procedure TSortieAnaDlg.FinSAScrollChange(Sender: TObject);
begin with sortieAnalogique do begin
     if DebutSAScroll.position>FinSAScroll.position-8 then
        FinSAScroll.position := DebutSAScroll.position+8;
     EditFinSA.text := FormatUnite(ValeurReal(FinSAScroll.position));
     GtsMainForm.EcritOrphy('XSA '+IntToStr(DebutSAScroll.position));
end end;

procedure TSortieAnaDlg.OKBtnClick(Sender: TObject);
begin
     with sortieAnalogique do begin
        Active := true;
        Nom := EditNomSA.text;
        FinSortie := FinSAScroll.position;
        DebutSortie := DebutSAScroll.position;
        inverse := inverseCB.checked;
        calcVecteur;
     end;
end;

procedure TSortieAnaDlg.FormActivate(Sender: TObject);
begin
     activation := true;
     with sortieAnalogique do begin
        FinSAScroll.position :=FinSortie;
        EditFinSA.text := FormatUnite(ValeurReal(FinSAScroll.position));
        DebutSAScroll.position := DebutSortie;
        EditDebutSA.text := FormatUnite(ValeurReal(DebutSAScroll.position));
        EditNomSA.text := nom;
        GtsMainForm.EcritOrphy('XSA '+IntToStr(DebutSortie));
        InverseCB.Checked := inverse;
        MajDeltat;
     end;
     activation := false;
end;

procedure TSortieAnaDlg.SortieRGClick(Sender: TObject);
begin
    if not activation then with sortieAnalogique do begin
       EditFinSA.text := FormatUnite(ValeurReal(FinSAScroll.position));
       EditDebutSA.text := FormatUnite(ValeurReal(DebutSAScroll.position));
    end;
end;

procedure TSortieAnaDlg.HelpBtnClick(Sender: TObject);
begin
   Application.HelpContext(HELP_SortieAnalogique)
end;

procedure TSortieAnaDlg.DeltatSBtnDownClick(Sender: TObject);
begin with sortieAnalogique do
     if deltatSA>100 then dec(deltatSA,100);
     MajDeltat;
end;

procedure TSortieAnaDlg.DeltatSBtnUpClick(Sender: TObject);
begin with sortieAnalogique do
     if deltatSA<10000 then inc(deltatSA,100);
     MajDeltat;
end;

procedure TSortieAnaDlg.MajDeltat;
begin
     DeltatEdit.text := FloatToStrF(sortieAnalogique.deltatSA/1000,ffFixed,4,2)+' s';
end;

end.
