unit Synchro;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, sysutils, ComCtrls, Spin,
  maths, gtsutil, gtsdef, graphe, constgts, aidekey;

type
  TSynchroDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    SynchroRG: TRadioGroup;
    Notebook: TPageControl;
    FrontTS: TTabSheet;
    SeuilTS: TTabSheet;
    RelaxeTS: TTabSheet;
    ClavierTS: TTabSheet;
    EFRG: TRadioGroup;
    SensSeuilRG: TRadioGroup;
    GroupBox1: TGroupBox;
    RazSeuilBtn: TSpeedButton;
    SeuilScroll: TScrollBar;
    Memo1: TMemo;
    AideMemo: TMemo;
    AbscisseRG: TRadioGroup;
    Label1: TLabel;
    LabelSeuil: TLabel;
    BougeTS: TTabSheet;
    GroupBox2: TGroupBox;
    LabelBouge: TLabel;
    BougeScroll: TScrollBar;
    BougeRG: TRadioGroup;
    Memo2: TMemo;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SynchroRGClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure RazSeuilBtnClick(Sender: TObject);
    procedure SeuilScrollChange(Sender: TObject);
    procedure AbscisseRGClick(Sender: TObject);
    procedure BougeScrollChange(Sender: TObject);
  private
    NumVoieAbs : array[0..5] of indiceVoie;
    voies : indiceVoie;
  public
  end;

var
  SynchroDlg: TSynchroDlg;

implementation

{$R *.DFM}

procedure TSynchroDlg.OKBtnClick(Sender: TObject);
begin with grapheGts do begin
     modeSynchro := TmodeSynchro(synchroRG.itemIndex);
     frontSynchro := EFRG.itemIndex;
     synchroUp := boolean(sensSeuilRG.itemIndex);
     seuilSynchro := SeuilScroll.position;
     deltaBouge := BougeScroll.position;     
     if synchroRG.itemIndex=3
        then grapheGTS.voieSynchro := NumVoieAbs[AbscisseRG.itemIndex];
     if synchroRG.itemIndex=4
        then grapheGTS.voieSynchro := NumVoieAbs[BougeRG.itemIndex]
end end;

procedure TSynchroDlg.FormActivate(Sender: TObject);
var voie : indiceVoie;
    texte : string;
begin with grapheGts do begin
     synchroRG.itemIndex := ord(modeSynchro);
     sensSeuilRG.itemIndex := ord(synchroUp);
     EFRG.itemIndex := frontSynchro;
     Notebook.activePageIndex := SynchroRG.itemIndex;
     AbscisseRG.items.clear;
     BougeRG.Items.Clear;
     for voie := voieA to voieAnaMax do
         with voieOrphy[voie] do if active then begin
            if length(signif)<length(nom)
               then texte := nom
               else if (length(nom)+length(signif))<16
                   then texte := nom+'/'+signif
                   else texte := signif;
            AbscisseRG.items.Add(texte);
            BougeRG.items.Add(texte);
            numVoieAbs[pred(abscisseRG.items.count)] := voie;
            if (voie=voieSynchro) then begin
               AbscisseRG.itemIndex := pred(abscisseRG.items.count);
               BougeRG.itemIndex := pred(bougeRG.items.count);
            end;
      end;
      if AbscisseRG.itemIndex=-1 then begin
          AbscisseRG.itemIndex := 0;
          BougeRG.ItemIndex := 0;
          voieSynchro := NumVoieAbs[0];
      end;
      voieS := voieSynchro;
      SeuilScroll.Position := SeuilSynchro;
      BougeScroll.Position := DeltaBouge;      
end end;

procedure TSynchroDlg.SynchroRGClick(Sender: TObject);
begin
     Notebook.ActivePageIndex := SynchroRG.itemIndex
end;

procedure TSynchroDlg.HelpBtnClick(Sender: TObject);
begin
     if SynchroRG.itemIndex<4
        then Application.HelpContext(HELP_Synchronisation)
        else Application.HelpContext( HELP_Synchronisation)
end;

procedure TSynchroDlg.RazSeuilBtnClick(Sender: TObject);
begin
     SeuilScroll.Position := 128
end;

procedure TSynchroDlg.SeuilScrollChange(Sender: TObject);
begin
     with grapheGTS.voieOrphy[voieS] do begin
          valeurAff := valeurReal(SeuilScroll.position);
          LabelSeuil.caption := affVoltmetre+' '+nomUnite;
     end;
end;

procedure TSynchroDlg.AbscisseRGClick(Sender: TObject);
begin
     voieS := NumVoieAbs[(sender as TradioGroup).itemIndex]
end;

procedure TSynchroDlg.BougeScrollChange(Sender: TObject);
begin
     LabelBouge.caption := intToStr(BougeScroll.position);
end;

end.
