unit Balayage;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysutils,
  maths, gtidef, gtimain, tradFormU;

type
  TBalayageDlg = class(TtradForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Panel1: TPanel;
    MonocoupCB: TCheckBox;
    GroupBox1: TGroupBox;
    NbreEdit: TEdit;
    NbreSpin: TSpinButton;
    GroupBox2: TGroupBox;
    DeltatLabel: TLabel;
    DureeEdit: TEdit;
    DureeSpin: TSpinButton;
    MiniLabel: TLabel;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure DureeSpinDownClick(Sender: TObject);
    procedure DureeSpinUpClick(Sender: TObject);
    procedure DureeEditChange(Sender: TObject);
    procedure DureeEditExit(Sender: TObject);
    procedure NbreEditExit(Sender: TObject);
    procedure NbreSpinDownClick(Sender: TObject);
    procedure NbreSpinUpClick(Sender: TObject);
  private
    dureeMin : single;
    modifDuree : boolean;
    Procedure SetNombre;
    Procedure SetDuree;
    Procedure GetMantisse(var mantisse : integer;var coeff : single);
    Procedure Maj;
  public
  end;

var
  BalayageDlg: TBalayageDlg;

implementation

{$R *.DFM}

Procedure TBalayageDlg.SetNombre;
begin with GtiMainForm do begin
    if NbreInter<minPoints then NbreInter := minPoints;
    if NbreInter>maxVecteur then NbreInter := maxVecteur;
    AjusteDeltat;
    DureeBalayage := deltat*NbreInter;
    Maj;
end end;

Procedure TBalayageDlg.SetDuree;
begin with GtiMainForm do begin
    if dureeBalayage<dureeMin then dureeBalayage := dureeMin;
    if dureeBalayage>dureeMax then dureeBalayage := dureeMax;
    AjusteNiDt;
    Maj;
end end;

Procedure TBalayageDlg.GetMantisse(var mantisse : integer;var coeff : single);
var exposant : single;
begin with GtiMainForm do begin
      exposant := MyInt(log(abs(dureeBalayage)));
      coeff := exp(exposant*ln10);
      mantisse := round(int(abs(dureeBalayage)/coeff));
end end;

procedure TBalayageDlg.Maj;
begin with GtiMainForm do begin
    deltatLabel.caption := chaineDuree(deltat);
    NbreEdit.text := IntToStr(NbreInter);
    DureeEdit.text := chaineDuree(DureeBalayage);
end end;




end.
